=begin
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
# Designed December 2013 by Fredo6

# Permission to use this software for any purpose and without fee is hereby granted
# Distribution of this software for commercial purpose is subject to:
#  - the expressed, written consent of the author
#  - the inclusion of the present copyright notice in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name			:   Lib6Magnifier.rb
# Original Date	:   30 Nov 2013
# Description	:   Manage a magnifier glass in the current view
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
=end

module Traductor

#------------------------------------------------------------------
# Text for Magnifier
#------------------------------------------------------------------


T6[:TIT_Magnifier] = "Magnifier Glass"
T6[:TIT_MagnifierEditionMode] = "Edition Mode"
T6[:TIP_MagnifierExit] = "Exit Magnifier (Escape or double-click in viewport)"

T6[:BOX_MagnifierZoom] = "Zoom"
T6[:BOX_MagnifierZoomAuto] = "Auto"
T6[:TIP_MagnifierZoomAuto] = "Automatically adjust the zoom factor based on defect pointed at"
T6[:T_MSG_ZoomFactor] = "Zoom Factor"
T6[:MSG_MagnifierStatusBarFreeze] = "Click to Freeze"
T6[:MSG_MagnifierStatusBarUnFreeze] = "Click to UnFreeze"
T6[:MSG_MagnifierStatusBar1] = "Ctrl + MouseWheel to zoom in / out"
T6[:MSG_MagnifierStatusBar2] = "TAB to switch Palette / Tracking Window"
T6[:MSG_MagnifierStatusBar3] = "Zoom value in VCB"
T6[:MSG_MagnifierStatusBar4] = "Double-Click or Escape to exit Magnifier mode"

T6[:TIP_MagnifierToggleVertex] = "Show / Hide marks for vertices"
T6[:TIP_MagnifierZoomIn] = "Zoom IN"
T6[:TIP_MagnifierZoomOut] = "Zoom OUT"
T6[:TIP_MagnifierZoomValue] = "Click to change the Zoom Factor"
T6[:TIP_MagnifierDisplayMode] = "Display mode for the magnifier glass"
T6[:TIP_MagnifierDisplayModeCentered] = "CENTERED: magnifier glass is centered on the cursor"
T6[:TIP_MagnifierDisplayModeShifted] = "SHIFTED: magnifier glass is shifted from the cursor"
T6[:TIP_MagnifierDisplayModeFixed] = "FIXED: magnifier glass is shown in the floating palette"
T6[:TIP_MagnifierFreeze] = "Freeze at position"
T6[:TIP_MagnifierUnFreeze] = "Unfreeze"
T6[:PROMPT_MagnifierZoomValue] = "Zoom Factor"

T6[:MNU_MagnifierHelp] = "Help on Magnifier Glass"
T6[:MNU_MagnifierZoomAuto] = "Toggle Auto Zoom"
T6[:MNU_MagnifierSwitchFixed] = "Switch to fixed Glass mode"
T6[:MNU_MagnifierSwitchCentered] = "Switch to Centered Glass mode"
T6[:MNU_MagnifierSwitchShifted] = "Switch to Shifted Glass mode"
T6[:MNU_MagnifierShowVertices] = "Show marks for vertices"
T6[:MNU_MagnifierHideVertices] = "Hide marks for vertices"
T6[:MNU_MagnifierZoomMin] = "Set to Minimum Zoom Factor"
T6[:MNU_MagnifierZoomMax] = "Set to Maximum Zoom Factor"

T6[:TIP_MagnifierEdition_pan_shift] = "(click-release or click-drag) and Pan (Shift + click-drag)"
T6[:TIP_MagnifierEdition_pan] = "(click-release) and Pan (click-drag)"
T6[:TIP_MagnifierEdition__select] = "Selection"
T6[:TIP_MagnifierEdition__unselect] = "Unselect ALL"
T6[:TIP_MagnifierEdition__move] = "Move entities"
T6[:TIP_MagnifierEdition__tape] = "Measure distance"
T6[:TIP_MagnifierEdition__eraser] = "Edge Eraser"
T6[:TIP_MagnifierEdition__repair] = "Repair Now"
T6[:TIP_MagnifierEdition__ignore] = "Ignore Repair"
T6[:TIP_MagnifierEdition__pencil] = "Draw edge"

T6[:HLP_Magnifier_SectionGeneral] = "General and Zooming"
T6[:HLP_Magnifier_SectionEdit] = "Edition Mode in Frozen View"

T6[:HLP_Magnifier_ZoomSU] = "Zoom in/out in the Sketchup viewport"
T6[:HLP_Magnifier_ZoomGlass] = "Zoom in/out in the Magnifier Glass"
T6[:HLP_Magnifier_VCB] = "Type the value of the Zoom factor (ex: 30)"
T6[:HLP_Magnifier_ZoomIN] = "Zoom IN"
T6[:HLP_Magnifier_ZoomOUT] = "Zoom OUT"
T6[:HLP_Magnifier_ZoomMIN] = "Zoom out to MINIMUM value"
T6[:HLP_Magnifier_ZoomMAX] = "Zoom in to MAXIMUM value"
T6[:HLP_Magnifier_DisplayMode] = "Cycle through display mode (fixed, centered, shifted)"
T6[:HLP_Magnifier_Zooming] = "Zooming"
T6[:HLP_Magnifier_Panning] = "Panning"
T6[:HLP_Magnifier_PanningKeys] = "Click, Drag and Release in view (supported by all tools)"
T6[:HLP_Magnifier_Select] = "Select tool"
T6[:HLP_Magnifier_SelectKeys] = "Click, double-click, Triple Click with support of Shift and Ctrl"
T6[:HLP_Magnifier_Del] = "DEL key"
T6[:HLP_Magnifier_DelKeys] = "Erase the current selection if any"
T6[:HLP_Magnifier_Tape] = "Tape Measure"
T6[:HLP_Magnifier_TapeKeys] = "Click-Release, drag and then click-release"
T6[:HLP_Magnifier_Move] = "Move tool"
T6[:HLP_Magnifier_MoveKeys] = "Move tool"
T6[:HLP_Magnifier_Eraser] = "Edge Eraser"
T6[:HLP_Magnifier_EraserKeys] = "Click-Release on an edge or a vertex"
T6[:HLP_Magnifier_Exit] = "EXIT Magnifier (or Double-click in empty space)"
T6[:HLP_Magnifier_UnFreeze] = "Unfreeze view"
T6[:HLP_Magnifier_UnFreezeKeys] = "Click outside Magnifier window or press Return"


#=============================================================================================
#=============================================================================================
# Class FacePicker: main class for the Face Picker Interactive tool
#=============================================================================================
#=============================================================================================

T6[:DEFAULT_SectionMagnifier] = "Magnifier Glass"
T6[:DEFAULT_MagnifierSize] = "Size of the Magnifier"
T6[:DEF_MagnifierSizeSmall] = "Small"
T6[:DEF_MagnifierSizeRegular] = "Medium"
T6[:DEF_MagnifierSizeLarge] = "Large"
T6[:DEFAULT_MagnifierPanningMoveTape] = "Enable Panning for the Tape and Move tool in Edition mode (otherwise, available with Shift or Ctrl)"

class Magnifier

#-----------------------------------------------------------
# GLOBAL: Global methods for sub-classing
#-----------------------------------------------------------

#Configure Palette Default Parameters
def Magnifier.config_default_parameters
	MYDEFPARAM.separator :DEFAULT_SectionMagnifier
	sizes = [['S', :DEF_MagnifierSizeSmall], ['M', :DEF_MagnifierSizeRegular], ['L', :DEF_MagnifierSizeLarge]]
	MYDEFPARAM.declare :DEFAULT_MagnifierSize, 'M', "H:", T6[sizes]
	MYDEFPARAM.declare :DEFAULT_MagnifierPanningMoveTape, true, "B"
end

#INIT: Class initialization
def initialize(*hargs)
	MYPLUGIN.load_body(self, __FILE__)
	initialize__(*hargs)
end

end #class Magnifier

end	#End Module Traductor
