=begin
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
# Copyright © 2014 Fredo6 - Designed and written Mar 2014 by Fredo6
#
# Permission to use this software for any purpose and without fee is hereby granted
# Distribution of this software for commercial purpose is subject to:
#  - the expressed, written consent of the author
#  - the inclusion of the present copyright notice in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name			:   Lib6OriginTargetPicker.rb
# Original Date	:   11 Mar 2014 
# Description	:   Manage the picking of an origin and a target with second-level inferences (loader)
# IMPORTANT		:	DO NOT TRANSLATE STRINGS in the source code
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
=end

module Traductor

#=============================================================================================
#=============================================================================================
# Class OriginTargetPicker: Class for picking an Origin and a Target with inferences
#=============================================================================================
#=============================================================================================

T6[:TXT_OTPickerSection] = "Inference settings for Origin - Target picker"

class OriginTargetPicker

def OriginTargetPicker.default_parameters
	MYDEFPARAM.separator :DEFAULT_DrawAlong_Section, nil, T6[:TXT_OTPickerSection]
	MYDEFPARAM.declare :DEFAULT_OTPicker_PixelPrecision, 7, 'I:>=5<=15', nil, T6[:T_DEF_PixelPrecision]
	MYDEFPARAM.declare :DEFAULT_OTPicker_AlignAngle, 6, 'I:>=5<=15', nil, T6[:T_DEF_AlignAngle]
	txori = " [#{T6[:T_MSG_Origin]}]"
	txtar = " [#{T6[:T_MSG_Target]}]"
	MYDEFPARAM.declare :DEFAULT_OTPicker_RemoteDelayOrigin, 1.0, 'F:>=0.5<=10.0', nil, T6[:T_DEF_RemoteDelay] + txori
	MYDEFPARAM.declare :DEFAULT_OTPicker_RemoteDelayTarget, 1.0, 'F:>=0.1<=10.0', nil, T6[:T_DEF_RemoteDelay] + txtar
end

#INIT: Class instance initialization
def initialize(hsh_parameters, *hargs)
	MYPLUGIN.load_body(self, __FILE__)
	initialize__(hsh_parameters, *hargs)
end

end	#class OriginTargetPicker

end	#End Module Traductor
