=begin
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
# Designed by Fredo6 - Copyright April 2009

# Permission to use this software for any purpose and without fee is hereby granted
# Distribution of this software for commercial purpose is subject to:
#  - the expressed, written consent of the author
#  - the inclusion of the present copyright notice in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name			:   Lib6Palette.rb
# Original Date	:   8 May 2009 - version 1.0
# Description	:   Interactive button palette management
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
=end


module Traductor

#--------------------------------------------------------------------------------------------------------------
#--------------------------------------------------------------------------------------------------------------
# Class Palette: Button Palette management
#--------------------------------------------------------------------------------------------------------------			 
#--------------------------------------------------------------------------------------------------------------			 

T6[:DEFAULT_SectionPalette] = "Palette Configuration"
T6[:DEFAULT_PalettePos] = "Palette in Top position"
T6[:DEFAULT_PaletteShrinked] = "Palette shrinked"
T6[:DEFAULT_PaletteSideLeft] = "Palettes on Left side"
T6[:DEFAULT_PaletteMessageZone] = "Show Message area"
T6[:DEFAULT_PaletteRetina] = "Retina Screen"

class Palette

#----------------------------------------------------------------------------
# Managing default parameters
#----------------------------------------------------------------------------

#Configure Palette Default Parameters
def Palette.config_default_parameters
	MYDEFPARAM.separator :DEFAULT_SectionPalette
	MYDEFPARAM.declare :DEFAULT_PalettePos, true, 'B'
	MYDEFPARAM.declare :DEFAULT_PaletteShrinked, false, 'B'
	MYDEFPARAM.declare :DEFAULT_PaletteSideLeft, true, 'B'
	MYDEFPARAM.declare :DEFAULT_PaletteMessageZone, true, 'B'
	MYDEFPARAM.declare :DEFAULT_PaletteRetina, false, 'B'
end

#Create a palette instance
def initialize(*hargs)
	MYPLUGIN.load_body(self, __FILE__)
	initialize__(*hargs)
end

end	# class Palette

#--------------------------------------------------------------------------------------------------------------
#--------------------------------------------------------------------------------------------------------------
# Class PaletteSuperTool: used for subclassing the Tools and provide palette management
#--------------------------------------------------------------------------------------------------------------			 				   
#--------------------------------------------------------------------------------------------------------------			 				   

class PaletteSuperTool

def set_palette(palette)
	@palette = palette
end

def draw(view)
	status = Hilitor.draw_all_active(view)
	@palette.draw view if @palette && !status
end

def onMouseLeave(view)
	@palette.onMouseLeave(view) if @palette
end

def onMouseEnter(view)
	@palette.onMouseEnter(view) if @palette
	view.invalidate
end	

def onLButtonDown(flags, x, y, view)
	@palette.onLButtonDown(flags, x, y, view) if @palette
end

def onLButtonUp(flags, x, y, view)
	@palette.onLButtonUp(flags, x, y, view) if @palette
end

def onLButtonDoubleClick(flags, x, y, view)
	@palette.onLButtonDoubleClick(flags, x, y, view) if @palette
end

def onMouseMove(flags, x, y, view)
	@palette.onMouseMove(flags, x, y, view) if @palette
end
	
def onSetCursor
	@palette.onSetCursor if @palette
end
	
end	#End class PaletteSuperTool

end	#module Traductor

