=begin
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
# Designed December 2013 by Fredo6

# Permission to use this software for any purpose and without fee is hereby granted
# Distribution of this software for commercial purpose is subject to:
#  - the expressed, written consent of the author
#  - the inclusion of the present copyright notice in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name			:   Lib6Magnifier.rb
# Original Date	:   30 Nov 2013
# Description	:   Manage a magnifier glass in the current view
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
=end

module Traductor

#------------------------------------------------------------------
# Text for Magnifier
#------------------------------------------------------------------


T6[:TIT_Magnifier] = "Magnifier Glass"
T6[:TIT_MagnifierEditionMode] = "Edition Mode"
T6[:TIP_MagnifierExit] = "Exit Magnifier (Escape or double-click in viewport)"

T6[:BOX_MagnifierZoom] = "Zoom"
T6[:BOX_MagnifierZoomAuto] = "Auto"
T6[:TIP_MagnifierZoomAuto] = "Automatically adjust the zoom factor based on defect pointed at"
T6[:T_MSG_ZoomFactor] = "Zoom Factor"
T6[:MSG_MagnifierStatusBarFreeze] = "Click to Freeze"
T6[:MSG_MagnifierStatusBarUnFreeze] = "Click to UnFreeze"
T6[:MSG_MagnifierStatusBar1] = "Ctrl + MouseWheel to zoom in / out"
T6[:MSG_MagnifierStatusBar2] = "TAB to switch Palette / Tracking Window"
T6[:MSG_MagnifierStatusBar3] = "Zoom value in VCB"
T6[:MSG_MagnifierStatusBar4] = "Double-Click or Escape to exit Magnifier mode"

T6[:TIP_MagnifierToggleVertex] = "Show / Hide marks for vertices"
T6[:TIP_MagnifierZoomIn] = "Zoom IN"
T6[:TIP_MagnifierZoomOut] = "Zoom OUT"
T6[:TIP_MagnifierZoomValue] = "Click to change the Zoom Factor"
T6[:TIP_MagnifierDisplayMode] = "Display mode for the magnifier glass"
T6[:TIP_MagnifierDisplayModeCentered] = "CENTERED: magnifier glass is centered on the cursor"
T6[:TIP_MagnifierDisplayModeShifted] = "SHIFTED: magnifier glass is shifted from the cursor"
T6[:TIP_MagnifierDisplayModeFixed] = "FIXED: magnifier glass is shown in the floating palette"
T6[:TIP_MagnifierFreeze] = "Freeze at position"
T6[:TIP_MagnifierUnFreeze] = "Unfreeze"
T6[:PROMPT_MagnifierZoomValue] = "Zoom Factor"

T6[:MNU_MagnifierHelp] = "Help on Magnifier Glass"
T6[:MNU_MagnifierZoomAuto] = "Toggle Auto Zoom"
T6[:MNU_MagnifierSwitchFixed] = "Switch to fixed Glass mode"
T6[:MNU_MagnifierSwitchCentered] = "Switch to Centered Glass mode"
T6[:MNU_MagnifierSwitchShifted] = "Switch to Shifted Glass mode"
T6[:MNU_MagnifierShowVertices] = "Show marks for vertices"
T6[:MNU_MagnifierHideVertices] = "Hide marks for vertices"
T6[:MNU_MagnifierZoomMin] = "Set to Minimum Zoom Factor"
T6[:MNU_MagnifierZoomMax] = "Set to Maximum Zoom Factor"

T6[:TIP_MagnifierEdition_pan_shift] = "(click-release or click-drag) and Pan (Shift + click-drag)"
T6[:TIP_MagnifierEdition_pan] = "(click-release) and Pan (click-drag)"
T6[:TIP_MagnifierEdition__select] = "Selection"
T6[:TIP_MagnifierEdition__unselect] = "Unselect ALL"
T6[:TIP_MagnifierEdition__move] = "Move entities"
T6[:TIP_MagnifierEdition__tape] = "Measure distance"
T6[:TIP_MagnifierEdition__eraser] = "Edge Eraser"
T6[:TIP_MagnifierEdition__repair] = "Repair Now"
T6[:TIP_MagnifierEdition__ignore] = "Ignore Repair"
T6[:TIP_MagnifierEdition__pencil] = "Draw edge"

T6[:HLP_Magnifier_SectionGeneral] = "General and Zooming"
T6[:HLP_Magnifier_SectionEdit] = "Edition Mode in Frozen View"

T6[:HLP_Magnifier_ZoomSU] = "Zoom in/out in the Sketchup viewport"
T6[:HLP_Magnifier_ZoomGlass] = "Zoom in/out in the Magnifier Glass"
T6[:HLP_Magnifier_VCB] = "Type the value of the Zoom factor (ex: 30)"
T6[:HLP_Magnifier_ZoomIN] = "Zoom IN"
T6[:HLP_Magnifier_ZoomOUT] = "Zoom OUT"
T6[:HLP_Magnifier_ZoomMIN] = "Zoom out to MINIMUM value"
T6[:HLP_Magnifier_ZoomMAX] = "Zoom in to MAXIMUM value"
T6[:HLP_Magnifier_DisplayMode] = "Cycle through display mode (fixed, centered, shifted)"
T6[:HLP_Magnifier_Zooming] = "Zooming"
T6[:HLP_Magnifier_Panning] = "Panning"
T6[:HLP_Magnifier_PanningKeys] = "Click, Drag and Release in view (supported by all tools)"
T6[:HLP_Magnifier_Select] = "Select tool"
T6[:HLP_Magnifier_SelectKeys] = "Click, double-click, Triple Click with support of Shift and Ctrl"
T6[:HLP_Magnifier_Del] = "DEL key"
T6[:HLP_Magnifier_DelKeys] = "Erase the current selection if any"
T6[:HLP_Magnifier_Tape] = "Tape Measure"
T6[:HLP_Magnifier_TapeKeys] = "Click-Release, drag and then click-release"
T6[:HLP_Magnifier_Move] = "Move tool"
T6[:HLP_Magnifier_MoveKeys] = "Move tool"
T6[:HLP_Magnifier_Eraser] = "Edge Eraser"
T6[:HLP_Magnifier_EraserKeys] = "Click-Release on an edge or a vertex"
T6[:HLP_Magnifier_Exit] = "EXIT Magnifier (or Double-click in empty space)"
T6[:HLP_Magnifier_UnFreeze] = "Unfreeze view"
T6[:HLP_Magnifier_UnFreezeKeys] = "Click outside Magnifier window or press Return"

#=============================================================================================
#=============================================================================================
# Class FacePicker: main class for the Face Picker Interactive tool
#=============================================================================================
#=============================================================================================

class Magnifier

#-----------------------------------------------------------
# INIT: Instance initialization
#-----------------------------------------------------------

#INIT: Class initialization
def initialize__(*hargs)
	#Initialization
	@model = Sketchup.active_model
	@selection = @model.selection
	@view = @model.active_view
	@ph = @view.pick_helper	
	@rendering_options = Sketchup.active_model.rendering_options
	@tr_id = Geom::Transformation.new
	@ogl = Traductor::OpenGL_6.new
	@button_down = false
	@dragging = false
	@pixel_dragging = 5
	@ip = Sketchup::InputPoint.new
	@glass_mode = :shifted
	@option_display_vertices = false
	@zoom_auto = true
	@pix_auto = 100
	@suops = Traductor::SUOperation.new
	
	#Zoom factors
	@zoom_range = [2, 4,6,8,10,15,20,40,60,80,100,150,200]
	for i in 1..20
		@zoom_range.push i * 100
	end	
	@zoom_range.push 2500, 3000, 4000, 5000
	@zoom_factor_min = @zoom_range.first
	@zoom_factor_max = @zoom_range.last
	set_size_spec MYDEFPARAM[:DEFAULT_MagnifierSize]
	@enable_panning_tape_move = MYDEFPARAM[:DEFAULT_MagnifierPanningMoveTape]
	
	#Loading the options
	option_load_save
	
	#Parsing the arguments
	hargs.each do |harg|	
		harg.each { |key, value|  parse_args(key, value) } if harg.class == Hash
	end
	
	#Nominal dimensions of the window
	nominal_box_init
	
	#Initialization
	text_init
	cursor_init
	init_VCB
	
	@magnifier_on = false
	@id_cursor = 0
	
	#Initializing the Z-Order info
	zorder_reset
end

#INIT: Parse the parameters of the Face Picker
def parse_args(key, value)
	skey = key.to_s
	case skey
	when /notify_proc/i
		@notify_proc = value
	when /dx/i
		@dx = value
	when /dy/i
		@dy = value
	when /delta/i
		@delta = value
	when /factor/i
		@zoom_factor = value
	end	
end	

#INIT: Set the size of the Magnifier glass
def set_size_spec(size_spec)
	case size_spec
	when /S/i
		@magni_size = 1.1
	when /L/i	
		@magni_size = 1.9
	else
		@magni_size = 1.5
	end	
end


#INIT: Initialize the nominal positions for the glass box
def nominal_box_init
	#Display window
	@dx = 252 unless @dx
	@dy = 252 unless @dy
	@dx *= @magni_size
	@dy *= @magni_size
	@dx2 = @dx / 2
	@dy2 = @dy / 2
	@delta = 30 unless @delta
	
	#Magnifier explore window
	adjust_pix
	
	#Display window
	@explore_box2d = [ORIGIN, ORIGIN, ORIGIN, ORIGIN]
	
	#Nominal Glass box
	@glass_center2d_nominal = Geom::Point3d.new @dx2, @dy2, 0
	@glass_box2d_nominal = []
	@glass_box2d_nominal[0] = Geom::Point3d.new 0, 0, 0
	@glass_box2d_nominal[1] = Geom::Point3d.new @dx, 0, 0
	@glass_box2d_nominal[2] = Geom::Point3d.new @dx, @dy, 0 
	@glass_box2d_nominal[3] = Geom::Point3d.new 0, @dy, 0

	@glass_frame_width = dec = 2
	@glass_frame2d_nominal = []
	@glass_frame2d_nominal[0] = Geom::Point3d.new -dec, -dec, 0
	@glass_frame2d_nominal[1] = Geom::Point3d.new @dx + dec, -dec, 0
	@glass_frame2d_nominal[2] = Geom::Point3d.new @dx + dec, @dy + dec, 0 
	@glass_frame2d_nominal[3] = Geom::Point3d.new -dec, @dy + dec, 0
	
	#Legend display in the glass window
	@scale_pix = @dx / 2
	@pt_text_nominal = Geom::Point3d.new 5, 2, 0

	pt1 = Geom::Point3d.new @dx - 5, 17, 0
	pt2 = pt1.offset X_AXIS, -@scale_pix
	pt3 = pt1.offset Y_AXIS, 3
	pt4 = pt1.offset Y_AXIS, -3
	pt5 = pt2.offset Y_AXIS, 3
	pt6 = pt2.offset Y_AXIS, -3
	@lines_scale_pix_nominal = [pt1, pt2, pt3, pt4, pt5, pt6]
	@center_scale_pix_nominal = Geom::Point3d.new pt1.x - @scale_pix/2, 2, 0

	#Mark for vertices
	@pts_mark0 = G6.pts_square 0, 0, 2
	
	#Hatch map for selected faces
	@lpoints_hatch_nominal = []
	dec = 5
	nx = @dx / dec
	ny = @dx / dec
	for ix in 0..nx
		x = ix * dec
		for iy in 0..ny
			y = 2 + iy * dec
			@lpoints_hatch_nominal.push Geom::Point3d.new(x + 2 * iy.modulo(2), y, 0)
		end	
	end

	#Display window
	@camera_direction = nil
end

#INIT: Initialize texts
def text_init
	txf = (@frozen) ? T6[:MSG_MagnifierStatusBarUnFreeze] : T6[:MSG_MagnifierStatusBarFreeze]
	@text_message_bar = [txf, T6[:MSG_MagnifierStatusBar1], T6[:MSG_MagnifierStatusBar2], T6[:MSG_MagnifierStatusBar3], T6[:MSG_MagnifierStatusBar4]].join ' ; '
	@text_message_label = T6[:T_MSG_ZoomFactor]
	
	@mnu_zoom_min = T6[:MNU_MagnifierZoomMin]
	@mnu_zoom_max = T6[:MNU_MagnifierZoomMax]

	@hsh_ops_titles = {}
	@hsh_ops_titles[:move] = T6[:T_OPS_move]
	@hsh_ops_titles[:eraser] = T6[:T_OPS_erase_edges]
	@hsh_ops_titles[:pencil] = T6[:T_OPS_draw_edge]
	@hsh_ops_titles[:delete] = T6[:T_OPS_erase_entities]
	@hsh_ops_titles[:make_face] = T6[:T_OPS_make_face]
	@hsh_ops_titles[:explode_curve] = T6[:T_OPS_explode_curve]
	
	@prefix_move = T6[:T_OPS_move]
	@tip_selection = T6[:T_TXT_Selection]
	@tip_vertex = T6[:T_TXT_Vertex]
	@tip_edge = T6[:T_TXT_Edge]
	@tip_face = T6[:T_TXT_Face]
	
	message_update if @magnifier_on
end

#INIT: Initialize the cursors for the Edition mode
def cursor_init
	@id_cursor_select = 633
	@id_cursor_select_plus = 634
	@id_cursor_select_minus = 636
	@id_cursor_select_plusminus = 635
	@id_cursor_pan = 668
	@id_cursor_tape = 638
	@id_cursor_move = 641
	@id_cursor_eraser = 645
	@id_cursor_pencil = 632
	@id_cursor_repair = Traductor.create_cursor "Cursor_Repair", 0, 0
	@id_cursor_ignore = Traductor.create_cursor "Cursor_Ignore", 0, 0
end

#INIT: Initialize colors
def colors_init	
	@su_edge_show_color = (@rendering_options['EdgeColorMode'] == 0)
	@su_edge_axis_color = (@rendering_options['EdgeColorMode'] == 2)
	@su_selection_color = @rendering_options['HighlightColor']
	@su_edge_color = @rendering_options['ForegroundColor']
	@su_face_front_color = @rendering_options['FaceFrontColor']
	@su_face_back_color = @rendering_options['FaceBackColor']
	@su_background_color = (@rendering_options['DrawGround']) ? @rendering_options['GroundColor'] : @rendering_options['BackgroundColor']
	
	@color_explorer_frame = 'green'
	@color_glass_frame = 'blue'
	@color_glass_frame_auto = 'green'
	@color_glass_frame_frozen = 'red'
	@color_vertices = 'blue'
	@color_highlight_edge = 'gray'
	@color_eraser_edge = 'red'
	
	@color_explore_box = Sketchup::Color.new 'yellow'
	@color_explore_box.alpha = 0.05
	
	@hsh_boxinfo_vector = { :bk_color => 'lightblue', :fr_color => 'green' }	

	@capa_transparency = G6.su_capa_color_polygon
end

#-------------------------------------------
# OPTION: Switching on and off
#-------------------------------------------

#ACTIVATION: Activate the magnifier on / off
def activation(state_on)
	return if state_on == @magnifier_on
	@magnifier_on = state_on
	if @magnifier_on
		option_load_save
		@frozen = false
		colors_init
		text_init
		camera_execute_change
	else
		message_clear
		option_load_save true
		@notify_proc.call(:exit) if @notify_proc
	end
end

#UNDO: Handle undo by user
def handle_undo
	camera_execute_change
end

#UNDO: Handle the escape key depending on current mode
def handle_escape
	(@magnifier_on && @frozen) ? edition_handle_escape : false
end

#OPTION: Toggle the display mode: glass or floating palette
def toggle_display_mode
	if @frozen
		set_display_mode @glass_mode_old
	else
		case @glass_mode_old
		when :shifted
			set_display_mode nil
		when :centered
			set_display_mode :shifted
		else
			set_display_mode :centered
		end	
	end	
end

#OPTION: Toggle the display mode: glass or floating palette
def set_display_mode(mode)
	case mode
	when :centered, :shifted
		@glass_mode = mode
	else
		@glass_mode = nil
	end	
	@glass_mode_old = @glass_mode
	text_init
	if @frozen
		toggle_freeze 
	else	
		onMouseMove_zero
	end	
end

#OPTION: Toggle the display of vertices
def toggle_display_vertices
	@option_display_vertices = !@option_display_vertices
	onMouseMove_zero
end

#OPTION: Toggle the freeze on or off
def toggle_freeze
	@frozen = !@frozen
	
	title = T6[:TIT_Magnifier]
	if @frozen
		title += " (#{T6[:TIT_MagnifierEditionMode]})"
		@palette.floating_set_title(@flpal, title)
		@glass_mode_old = @glass_mode
		@glass_mode = nil
		@edition_tool = :select
		instructions_after
	else
		@palette.floating_set_title(@flpal, title)
		@glass_mode = @glass_mode_old
		@edition_instructions = nil
	end	
	text_init
	onMouseMove_zero
end

#OPTION: Return the frozen status of the magnifier
def is_frozen?
	@frozen
end
	
#OPTION: Toggle the zoom Auto
def toggle_zoom_auto
	@zoom_auto = !@zoom_auto
end

def option_load_save(flg_save=false)
	dico = "LibFredo6"
	section = "Magnifier"
	
	#Saving parameters
	if flg_save
		hsh = {}
		hsh[:glass_mode] = @glass_mode_old
		hsh[:zoom_factor] = @zoom_factor_last
		hsh[:zoom_auto] = @zoom_auto
		hsh[:display_vertices] = @option_display_vertices
		Sketchup.write_default dico, section, 
		sparam = hsh.inspect.gsub('"', "'")
		Sketchup.write_default dico, section, sparam	
		
	#Loading parameters	
	else
		sparam = Sketchup.read_default dico, section
		hsh = {}
		if sparam
			hsh = eval(sparam) rescue {}
		end
		@glass_mode = @glass_mode_old = hsh.fetch(:glass_mode, :shifted)
		@zoom_factor_last = @zoom_factor = hsh.fetch(:zoom_factor, 10)
		@zoom_auto = hsh.fetch(:zoom_auto, true)
		@option_display_vertices = hsh.fetch(:display_vertices, false)
	end
end

#-------------------------------------------
# ALGO: Computing Boxes
#-------------------------------------------

#ALGO: Compute the coordinates of the top left inner corner of the glass box
def algo_position_glassbox
	if @glass_mode == :centered
		return Geom::Point3d.new(@center2d.x - @dx2, @center2d.y - @dy2)
	end
	
	widf = @glass_frame_width
	wx2 = @wid_explore_box2
	wy2 = @hgt_explore_box2
	vpwidth = @view.vpwidth
	vpheight = @view.vpheight
	
	#Base coordinates
	x0 = @center2d.x - wx2 - widf
	y0 = @center2d.y - wy2 - @delta - widf - @dy
	
	#Forcing the glass window within the viewport
	xmax = vpwidth - @dx - 2 * widf - 1
	if x0 < 0
		x0 = 0
	elsif x0 > xmax
		x0 = xmax
	end

	ymax = vpheight - @dy - 2 * widf - 1
	if y0 < 0
		y0 = 0
	elsif y0 > ymax
		y0 = ymax
	end
	
	#Adjusting for top left and top right corner clashes
	if @center2d.y < @dx + @delta + wx2 
		x0 = @center2d.x + wx2 + @delta
		x0 = @center2d.x - @dx - @delta - wx2 if @center2d.x > vpwidth - @dx - @delta - wx2
	end
	
	#Returning the top-left corner of the inner rectangle
	Geom::Point3d.new x0 + widf, y0 + widf, 0
end

#ALGO: Compute the exploration and the display boxes
def algo_compute_boxes
	adjust_pix
	
	@nx = (@dx / @pix / @zoom_factor / 2.0).ceil #+ 1
	@ny = (@dy / @pix / @zoom_factor / 2.0).ceil #+ 1
	@nx = 2 if @nx < 2
	@ny = 2 if @ny < 2
	if @ip.vertex
		@nx = 3 if @nx < 3
		@ny = 3 if @ny < 3
	end
	
	#Compute the exploration box
	algo_compute_exploration_box
	
	#Compute the Glass box position by top_left corner
	corner = algo_position_glassbox
	
	#Inner rectangle for the glass box
	t = Geom::Transformation.translation corner
	@glass_center2d = t * @glass_center2d_nominal
	@glass_box2d = @glass_box2d_nominal.collect { |pt| t * pt }
	@glass_frame2d = @glass_frame2d_nominal.collect { |pt| t * pt }
	
	#Hatch map
	@lpoints_hatch = @lpoints_hatch_nominal.collect { |pt| t * pt }
	
	#Legend display in the glass box
	@pt_text = t * @pt_text_nominal
	@lines_scale_pix = @lines_scale_pix_nominal.collect { |pt| t * pt }
	@center_scale_pix = t * @center_scale_pix_nominal
	
	#Transformation between centers of boxes
	@tt_boxes = Geom::Transformation.translation @center2d.vector_to(@glass_center2d)	
	
	#Reduction scales in 2D and 3D (due to bug in view.screen_coords)
	reduc_ratio = 80.0
	@ts3d = Geom::Transformation.scaling @center3d, 1.0 / reduc_ratio
	@ts2d = Geom::Transformation.scaling @center2d, reduc_ratio	
end

#ALGO: Compute the exploration box
def algo_compute_exploration_box
	dx2 = 1.0 * @dx2 / @zoom_factor
	dy2 = 1.0 * @dy2 / @zoom_factor
	dx2 = 1 if dx2 < 1
	dy2 = 1 if dy2 < 1
	@wid_explore_box2 = dx2
	@hgt_explore_box2 = dy2
	dx = dx2 * 2
	dy = dy2 * 2
	x0, y0 = @center2d.x - dx2, @center2d.y - dy2
	
	#Computational explore box
	@explore_box2d[0] = Geom::Point3d.new x0, y0
	@explore_box2d[1] = Geom::Point3d.new x0 + dx, y0
	@explore_box2d[2] = Geom::Point3d.new x0 + dx, y0 + dy 
	@explore_box2d[3] = Geom::Point3d.new x0, y0 + dy 
	
	#Displayable explore box
	dmin = 5
	if dx < dmin
		dx = dmin
		dy = dx * dy2 / dy2
		x0, y0 = @center2d.x - dx/2, @center2d.y - dy/2
		@explore_box_display = []
		@explore_box_display[0] = Geom::Point3d.new x0, y0
		@explore_box_display[1] = Geom::Point3d.new x0 + dx, y0
		@explore_box_display[2] = Geom::Point3d.new x0 + dx, y0 + dy 
		@explore_box_display[3] = Geom::Point3d.new x0, y0 + dy 	
	else
		@explore_box_display = @explore_box2d
	end
end

#-------------------------------------------
# ALGO: Top level routine to refresh the scanning
#-------------------------------------------

#ALGO: Perform the base calculation when the view is changed
def camera_execute_change
	@change_timer = nil
	
	#Parameters for the view
	@camera_direction = @view.camera.direction
	unless @camera_direction_prev && @camera_direction.samedirection?(@camera_direction_prev)
		@camera_direction_prev = @camera_direction
	end	
	zorder_reset
	@eye = @view.camera.eye
	@plane_eye = [@eye, @camera_direction]

	#Resetting the scanning environment
	reset_grid_scanning
	
	#Updating the viewport
	message_update
	onMouseMove_zero
	edition_notify_change
	@view.invalidate
end

#ALGO: Notification of a change of view
def camera_changed
	if @change_timer
		UI.stop_timer @change_timer
		@change_timer = nil
	end
	@change_timer = UI.start_timer(0.1) { camera_execute_change }
end

#-------------------------------------------
# ALGO: Grid Scanning
#-------------------------------------------

#ALGO: Reset the variables for grid scanning
def reset_grid_scanning
	@hsh_picking = {}
end


#ALGO: Picking on a grid adjusted based on magnifying factor
def algo_grid_picking(view, x, y)	
	#Rounding the center of the exploration box
	xc = (x.round / @pix * @pix + @pix2)
	yc = (y.round / @pix * @pix + @pix2)

	#Test elements under mouse for the points of the grid
	face, edge, @tr, @parent = a = hover_under_mouse(0, @center2d.x, @center2d.y, view)
	@ls_grid = []
	ls_elt = []
	ls_elt.push a if a
	for ix in -@nx..@nx
		x = xc + ix * @pix
		next if x < 0
		for iy in -@ny..@ny
			y = yc + iy * @pix
			next if y < 0
			@ls_grid.push Geom::Point3d.new(x, y)
			key = x + y * 10000
			a = @hsh_picking[key]
			ls_elt.push a if a && a != 0
			next if a
			a = hover_under_mouse(0, x, y, view)
			@hsh_picking[key] = (a) ? a : 0
			ls_elt.push a if a && a != 0
		end
	end	
	
	#Initialize visibility stack
	@hsh_ent = {}
	lsfaces = []
	
	#Build the list of elements
	ls_elt.each do |a|
		face, edge, tr, parent = a
		
		#In case of standalone edges, include the nearby connected standalone edges
		if edge && edge.faces.length == 0
			id = key_entity(edge, tr)
			unless @hsh_ent[id]
				zorder_register id, edge, tr, parent
				[edge.start, edge.end].each do |vx|
					extend_edge_alone_from_vertex(vx, edge, tr, parent)
				end	
			end	
		end	
		
		#Storing faces
		if face
			id = key_entity(face, tr)
			unless @hsh_ent[id]
				info = [face, tr, parent]
				zorder_register id, face, tr, parent
				lsfaces.push info
			end	
		end
	end
		
	#Extending to adjacent faces
	hsh_excluded_faces = {}
	hsh_edge_treated = {}
	lsfaces.each do |info|
		face, tr, parent = info
		extend_faces_at_vertex(face, tr, parent, hsh_excluded_faces, hsh_edge_treated)	
	end
	
	#Getting the fake elements if any
	@fake_elements = (@notify_proc) ? @notify_proc.call(:fake_elements) : nil
	if @fake_elements
		@fake_elements.each do |a|
			id, seg, tr, parent = a
			zorder_register(*a) unless segment_outside_explorer_box?(seg, tr)
		end	
	end
	
	#Processing with the magnifying of entities
	process_faces_edges @hsh_ent.keys
end

#-------------------------------------------
# ZORDER: Z-Ordering of faces and edges
#-------------------------------------------

def zorder_reset
	@hsh_zod_info = {}
	@visi_list = []
	@visi_pile = []
	@hsh_in_pile = {}
	@hsh_ahead = {}
	@visi_stack = []
	@hsh_in_stack = {}
end

#ZORDER: Register a face or edge and insert it in the visibility stack
def zorder_register(id, e, tr, parent)
	@hsh_ent[id] = zorder_compute_info(id, e, tr, parent)
end

#ZORDER: Construct the ordered list of faces and edges for display
def zorder_simple_construct(lst_faces_edges_id)
	lst_faces_edges_id.each { |id| zorder_store_in_stack(id) unless @hsh_in_stack[id] }
	@visi_stack.collect { |a| a[1] }
end

#ZORDER: register the element in the ordered stack	
def zorder_store_in_stack(id0)
	@hsh_in_stack[id0] = true
	
	id, e, tr, parent, d0 = @hsh_zod_info[id0]
	
	@visi_stack.each_with_index do |a, i|
		d, id = a
		if d0 < d
			@visi_stack[i, 0] = [[d0, id0]]
			return
		end	
	end	
	@visi_stack.push [d0, id0]	
end
	
#ZORDER: Construct the ordered list of faces and edges for display
def zorder_complex_construct(lst_faces_edges_id)
	#Extracting the faces
	lst_faces = []
	lst_faces = lst_faces_edges_id.find_all { |id| @hsh_zod_info[id][1].instance_of?(Sketchup::Face) }
	lst_edges = lst_faces_edges_id.find_all { |id| @hsh_zod_info[id][1].instance_of?(Sketchup::Edge) }
	lst_fake_edges = lst_faces_edges_id.find_all { |id| id =~ /\Aedge/ }
	
	#Constructing the sorting information - Reinit if already too many faces
	if @visi_list.length > 100
		@visi_list = []
		@hsh_in_pile = {}
		@hsh_ahead = {}
	end	
	lst_faces.each { |id| zorder_piling id }
	
	#Considering only the faces under magnifier
	hsh_used = {}
	@visi_list.each { |id| hsh_used[id] = true if !lst_faces.include?(id) }
	
	#Constructing the pile of faces in order (most ahead first) with approximate sorting
	@visi_pile = []
	ntry = lst_faces.length
	for itry in 0..ntry	
		#For each face, computing the list of faces ahead of it and not already in the pile
		lsahead = []
		lst_faces.each do |id|
			next if hsh_used[id]
			ls = @hsh_ahead[id].find_all { |u| !hsh_used[u] }
			lsahead.push [ls.length, id]
		end	
		break if lsahead.empty?
		lsahead = lsahead[0..30]
		lsahead = lsahead.sort { |a, b| a.first <=> b.first }
		lsahead = lsahead.collect { |a| a[1] }
		
		#Selecting the face which has no or the fewest faces ahead of it
		#Best effort approach when there are conflicts
		id0 = lsahead[0]
		lsahead = lsahead.find_all { |a| !@hsh_ahead[a].find { |u| !hsh_used[u] } }
		lsahead = lsahead.sort { |id1, id2| zorder_distance_compare(id1, id2) }
		id0 = lsahead[0] if lsahead[0]
		
		#Inserting the face in the pile
		@visi_pile.push id0
		hsh_used[id0] = true
	end
	
	#Inserting the edges if any
	(lst_edges + lst_fake_edges).each do |eid|
		inserted = false
		@visi_pile.each_with_index do |fid, i|
			status = zorder_distance_compare(eid, fid)
			if status < 0
				@visi_pile[i,0] = eid
				inserted = true
				break
			end	
		end
		@visi_pile.push eid unless inserted
	end
	
	#Returning the list of elements ordered
	@visi_pile
end

#ZORDER: Register a face and insert it in the visibility stack
def zorder_piling(id0)
	#Already in the stack
	return if @hsh_in_pile[id0]
	@hsh_in_pile[id0] = true
	
	#Comparing the element with others. Unfortunately, comparison is not transitive
	@hsh_ahead[id0] = [] unless @hsh_ahead[id0]
	@visi_list.each_with_index do |id, i|
		@hsh_ahead[id] = [] unless @hsh_ahead[id]
		status = zorder_face_compare(id0, id)
		if status < 0
			@hsh_ahead[id].push id0
		elsif status > 0	
			@hsh_ahead[id0].push id
		end	
	end	
	
	#Inserting the element in the list
	@visi_list.push id0
end

#ZORDER: Basic comparison of Z-Order based on distance to camera
def zorder_distance_compare(id1, id2)
	id1, e1, tr1, parent1, d1 = @hsh_zod_info[id1]
	id2, e2, tr2, parent2, d2 = @hsh_zod_info[id2]
	(d1 <=> d2)
end

#ZORDER: Compare two faces with center vector algorithm
def zorder_face_compare(id1, id2)
	#Getting information about the 2 entities
	id1, face1, tr1, parent1, d1, center1, visidir1, bb1 = @hsh_zod_info[id1]
	id2, face2, tr2, parent2, d2, center2, visidir2, bb2 = @hsh_zod_info[id2]

	#Preferable not to compare when faces are disjointed on screen
	return 0 if bb1.intersect(bb2).empty?
	
	#Comparing two faces based on orientation of vector joining centres and the visibility normals at face
	vec = center1.vector_to(center2).normalize
	psmin = 0.05
	ps1 = vec % visidir1
	ps2 = vec % visidir2
	return -1 if ps1 > psmin && ps2 > psmin		#face1 is ahead of face2
	return +1 if ps2 < -psmin && ps1 < -psmin	#face1 is behind of face2
	0
end

#ZORDER: Compute information about element. All parameters are in 3D model coordinates
def zorder_compute_info(id, e, tr, parent)
	a = @hsh_zod_info[id]
	return a if a
	
	if e.instance_of?(Sketchup::Face)
		normal = G6.transform_vector(e.normal, tr).normalize
		visidir = (front_face_is_visible?(e, tr)) ? normal.reverse : normal
		bb = Geom::BoundingBox.new
		e.outer_loop.vertices.each { |vx| bb.add get_screen_coords(tr * vx.position) }
		center = tr * e.bounds.center
	elsif e.instance_of?(Sketchup::Edge)
		visidir = bb = nil
		center = tr * e.bounds.center
	elsif e.instance_of?(Array) && id =~ /\Aedge/
		visidir = bb = nil
		pt1, pt2 = e.collect { |pt| tr * pt }
		center = Geom.linear_combination 0.5, pt1, 0.5, pt2
	end
	d = @eye.distance center
	
	@hsh_zod_info[id] = [id, e, tr, parent, d, center, visidir, bb]
end
 
#----------------------------------------------------------
# ALGO: Screening and extension of face sand edges
#----------------------------------------------------------

#ALGO: Build a key based on entity id and parent for unicity across model
def key_entity(e, tr) ; "#{e.entityID} - #{tr.to_a}" ; end

#ALGO: Include adjacent vertex if they are alone (no face connected)
def extend_edge_alone_from_vertex(vx0, edge0, tr, parent, origin=nil, size=nil)
	lst = [[vx0, edge0]]
	while lst.length > 0
		vx, edge = lst.shift
		next if edge_outside_explorer_box?(edge, tr)
		vx.edges.each do |e|
			next if e == edge || e.faces.length > 0
			id = key_entity(e, tr)
			next if @hsh_ent[id]
			zorder_register id, e, tr, parent
			lst.push [e.other_vertex(vx), e] unless edge_outside_explorer_box?(e, tr)
		end	
	end		
end

#ALGO: Include faces at vertex if cursor is closed to a vertex
def extend_faces_at_vertex(face0, tr, parent, hsh_excluded_faces, hsh_edge_treated)
	lst = [face0]
	for i in 0..@nextend
		break if lst.empty?
		face = lst.shift
		face.edges.each do |edge|
			eid = key_entity(edge, tr)
			next if hsh_edge_treated[eid]
			hsh_edge_treated[eid] = true
			
			#Edge not in the explorer box
			next if edge_outside_explorer_box?(edge, tr)
			
			#Alone edge
			[edge.start, edge.end].each do |vx|
				vx.edges.each do |e|
					next if e.faces.length > 0
					id = key_entity(e, tr)
					next if @hsh_ent[id]
					zorder_register id, e, tr, parent
					vx2 = e.other_vertex(vx)
					extend_edge_alone_from_vertex(vx2, e, tr, parent)
				end
			end
			
			#Exploring adjacent faces
			edge.faces.each do |f|
				next if f == face 
				id = key_entity(f, tr)
				next if @hsh_ent[id] || hsh_excluded_faces[id]
				next if exclude_faces_outside(f, tr, parent, hsh_excluded_faces, id)
				zorder_register id, f, tr, parent
				lst.push f
			end	
		end	
	end
end

#ALGO: Exclude faces not in the explorer box
def exclude_faces_outside(face, tr, parent, hsh_excluded_faces, id)
	pts = face.outer_loop.vertices.collect { |vx| get_screen_coords(tr * vx.position) }
	return false if G6.polygon_within_box2d?(pts, @explore_box2d)
	hsh_excluded_faces[id] = true
	true
end

#ALGO: Check if an edge is outside the explorer box
def edge_outside_explorer_box?(edge, tr)
	pt1 = get_screen_coords(tr * edge.start.position)
	pt2 = get_screen_coords(tr * edge.end.position)
	!G6.segment_within_box2d?(pt1, pt2, @explore_box2d)
end

#ALGO: Check if an edge is outside the explorer box
def segment_outside_explorer_box?(seg, tr)
	pt1 = get_screen_coords(tr * seg[0])
	pt2 = get_screen_coords(tr * seg[1])
	!G6.segment_within_box2d?(pt1, pt2, @explore_box2d)
end

#ALGO: Magnify a set of face and edges
def process_faces_edges(lst_faces_edges_id)
	@magni_stack = []

	#Initialization
	instructions_before
	@text_scale_pix = nil
	nid = lst_faces_edges_id.length
	
	#No element
	if nid == 0
		instructions_after
		return
	end	
		
	#Large number of elements: use fast, simple algorithm based on distance
	if (nid / @zoom_factor > 50)
		linfo = zorder_simple_construct lst_faces_edges_id
		
	#Otherwise, use the double sorting algorithm for more accuracy	
	else
		linfo = zorder_complex_construct lst_faces_edges_id
	end
	
	#List of elements to draw in order
	hsh_used = {}
	@lst_elements = []
	linfo.each do |id|
		id0, e, tr, parent = @hsh_zod_info[id]
		if e.instance_of?(Sketchup::Face)
			e.edges.each do |edge|
				id = key_entity(edge, tr)
				next if hsh_used[id]
				hsh_used[id] = true
				next if edge_outside_explorer_box?(edge, tr)
				@lst_elements.push [id, edge, tr, parent]
			end			
			@lst_elements.push [id0, e, tr, parent]
		elsif e.instance_of?(Sketchup::Edge)
			id = key_entity(e, tr)
			next if hsh_used[id] || edge_outside_explorer_box?(e, tr)
			hsh_used[id] = true
			@lst_elements.push [id, e, tr, parent]
			
		elsif id0.class == String && id0 =~ /\Aedge/
			hsh_used[id] = true
			@lst_elements.push [id, e, tr, parent]
		end
	end	
	@lst_elements = @lst_elements.reverse
	
	#Calculating the 2D view with transformation and magnifying
	magnify_stack_compute
	
	#Adding the post instructions for drawing
	instructions_after
end
  
#ALGO: Build the magnify stack of elements to be displayed
def magnify_stack_compute
	return if @lst_elements.empty?
	
	#Transformations
	tsg = Geom::Transformation.scaling @glass_center2d, @zoom_factor
	@tr2d_magni = tsg * @tt_boxes
	@tr2d_magni_inv = @tr2d_magni.inverse

	#Compute the Scale length in 3D for scale display
	scale_length
	
	#Growing the faces and edges - Preparing the Drawing instructions 
	@lst_elements.each do |id, e, tr, parent|
	
		if e.instance_of?(Sketchup::Face)
			#Decomposing the face into triangles
			face = e
			selected = @selection.include?(face)
			mesh = face.mesh
			pts = mesh.points.collect { |pt| tr * pt }
			triangles = []
			mesh.polygons.each do |p| 
				triangles.push p.collect { |i| pts[i.abs-1] }
			end
			if front_face_is_visible?(face, tr)
				mat = face.material
				color = (mat) ? mat.color : @su_face_front_color
			else	
				mat = face.back_material
				color = (mat) ? mat.color : @su_face_back_color
			end
						
			#Contributing to the stack
			ltriangles2d = []
			triangles.each_with_index do |lpt, itri|
				triangle = lpt.collect { |pt| @tr2d_magni * get_screen_coords(pt) }
				lpt2d = G6.clip2d_rect_triangle(triangle, @glass_box2d)
				ltriangles2d.push lpt2d if lpt2d && lpt2d.length > 2
			end
			@magni_stack.push [:face, face, ltriangles2d, tr, parent, color]

		elsif e.instance_of?(Sketchup::Edge)
			#Getting screen coordinates of the edge
			edge = e
			edge_id = edge.entityID
			pt1 = get_screen_coords(tr * edge.start.position)
			pt2 = get_screen_coords(tr * edge.end.position)
			
			#Magnifying and Translating the points to the glass window
			pts_edge = [@tr2d_magni * pt1, @tr2d_magni * pt2]
			pts_info = G6.clip2d_rect_segment(pts_edge, @glass_box2d)
			next unless pts_info
			pts = pts_info.collect { |pt, i| pt }
			
			#Contributing to the stack
			@magni_stack.push [:edge, edge, pts, tr, parent]		
			
			#Checking if vertices visible. Adding marks for repair or show vertices option
			[edge.start, edge.end].each_with_index do |vx, i|
				pt = pts_edge[i]
				if Geom.point_in_polygon_2D(pt, @glass_box2d, true)
					@magni_stack.push [:vertex, vx, pt, tr, parent]
				end	
			end	

		elsif id.class == String && id =~ /\Aedge/
			pt1, pt2 = e.collect { |pt| get_screen_coords(tr * pt) }
			pts_edge = [@tr2d_magni * pt1, @tr2d_magni * pt2]
			pts_info = G6.clip2d_rect_segment(pts_edge, @glass_box2d)
			next unless pts_info
			pts = pts_info.collect { |pt, i| pt }
			@magni_stack.push [:fake_edge, id, pts, tr, parent]		
		
		end	
	end	#Loop on @lst_elements
	
	@magni_stack_inv = @magni_stack.reverse
	
	#Decorating the elements
	magnify_stack_decorate
end

#ALGO: Decorate the entities which are in the magnify stack
def magnify_stack_decorate
	return if @magni_stack.empty?

	@magni_stack.each do |a|
		case a.first
			
		#Face
		when :face
			type, face, ltriangles2d, tr, parent, color = a
			selected = @selection.include?(face)
			ltriangles2d.each do |lpt2d|
				@instructions2d.push [GL_POLYGON, lpt2d, color]
				if selected
					lpoints = @lpoints_hatch.find_all { |pt| Geom.point_in_polygon_2D(pt, lpt2d, false) }
					@instructions2d.push [GL_POINTS, lpoints, @su_selection_color] if lpoints.length > 0
				end	
			end	
		
		#Edge
		when :edge
			type, edge, pts, tr, parent	= a
			edge_id = edge.entityID
			
			#Creating the drawing instructions
			stippled = (edge.soft? || edge.smooth? || edge.hidden?)
			stipple = (stippled) ? '_' : ''
			color = nil
			width = 1
			
			#Reparations
			if @selected_repairs && @selected_repairs[edge_id]
				color, width0, stipple0 = @notify_proc.call(:entity_color, edge)
				width = width0 if width0
				stipple = stipple0 if stipple0
				#color = 'green'
				width += 2
				
			#Ignore	
			elsif @ignored_repairs && @ignored_repairs[edge_id]
				color, width0, stipple0 = @notify_proc.call(:entity_color, edge)
				width = width0 if width0
				stipple = stipple0 if stipple0
				#color = 'red'
				width += 2
				
			else
				color = @highlighted_edges[edge_id] if @highlighted_edges
				if color
					width += 2
				elsif @selection.to_a.include?(edge)
					color = @su_selection_color
					width = 2
				elsif @notify_proc 
					color, width0, stipple0 = @notify_proc.call(:entity_color, edge)
					width = width0 if width0
					stipple = stipple0 if stipple0
					width += 1 if edge.faces.length == 0
				end	
			end	
			unless color
				if @su_edge_show_color
					color = (edge.material) ? edge.material.color : @su_edge_color
				elsif @su_edge_axis_color
					vec = (tr * edge.start.position).vector_to(tr * edge.end.position)
					width += 3
					if vec.parallel?(X_AXIS)
						color = 'red'
					elsif vec.parallel?(Y_AXIS)
						color = 'lime'
					elsif vec.parallel?(Z_AXIS)
						color = 'blue'
					else
						color = @su_edge_color
					end
				else
					color = @su_edge_color
				end
				width += 1 if (edge.faces.length == 0)
			end	
			@instructions2d.push [GL_LINE_STRIP, pts, color, width, stipple]
			if @notify_proc && @notify_proc.call(:is_ignored, edge)
				ptmid = Geom.linear_combination 0.5, pts.first, 0.5, pts.last
				@instructions2d.concat G6.instructions_forbidden_at_point(ptmid)
			end	
		
		#Vertex
		when :vertex
			type, vx, pt, tr, parent = a
			vx_id = vx.entityID

			color = pix = nil	
			color, = @notify_proc.call(:entity_color, vx) if @notify_proc
			if color
				pix = 4
				if @selected_repairs && @selected_repairs[vx_id]
					#color = 'green'
					pix += 2
				elsif @ignored_repairs && @ignored_repairs[vx_id]
					#color = 'red'
					pix += 2
				end
			elsif @option_display_vertices
				pix = 3
				color = @color_vertices
			end
			@instructions2d.push [GL_POLYGON, G6.pts_square(pt.x, pt.y, pix), color] if pix
			if @notify_proc && @notify_proc.call(:is_ignored, vx)
				@instructions2d.concat G6.instructions_forbidden_at_point(pt)
			end	
		
		#Fake Edge
		when :fake_edge
			type, id, pts, tr, parent = a
			color, width, stipple = @notify_proc.call(:entity_color, id)
			if @selected_repairs && @selected_repairs[id]
				width += 2 if width
			elsif @ignored_repairs && @ignored_repairs[id]
				width += 2 if width
			end
			@instructions2d.push [GL_LINE_STRIP, pts, color, width, stipple]
			if @notify_proc && @notify_proc.call(:is_ignored, id)
				pt = Geom.linear_combination 0.5, pts[0], 0.5, pts[1]
				@instructions2d.concat G6.instructions_forbidden_at_point(pt)
			end	
				
		end	#end of case on type
	end
end

#ALGO: Correction for a bug in view.screen_coords
def get_screen_coords(pt_3d)
	if @camera_direction % @eye.vector_to(pt_3d) < 0
		pt = @ts2d * @view.screen_coords(@ts3d * pt_3d)
	else	
		pt = @view.screen_coords(pt_3d)
	end	
	pt.z = 0
	pt
end

#ALGO: Compute the 3D point corresponding to a 2D Point
#This is needed because view.pickray is not accurate enough
def get_point3d_from_2d(pt2d_ref, pt3d_ref)
	#Calculating the initial 3D point
	plane = [pt3d_ref, @camera_direction]
	xref = pt2d_ref.x
	yref = pt2d_ref.y
	ray = @view.pickray xref, yref
	pt3d = Geom.intersect_line_plane ray, plane
	
	#Vectors in 3D mapping the Horizontal and Vertical directions in 2D
	pt3dx = Geom.intersect_line_plane @view.pickray(xref+10, yref), plane
	pt3dy = Geom.intersect_line_plane @view.pickray(xref, yref+10), plane
	vecx = pt3dx.vector_to pt3d
	vecy = pt3dy.vector_to pt3d
	
	#Refining from the initial rough 3D point
	size = @view.pixels_to_model 1.0, pt3d
	pt2d = @view.screen_coords pt3d
	pt3d = pt3d.offset vecx, (pt2d.x - xref) * size
	pt3d = pt3d.offset vecy, (pt2d.y - yref) * size
	pt3d
end

#ALGO: Determine if the front (or back) face is the visible face
def front_face_is_visible?(face, tr)
	((tr * face.normal) % @eye.vector_to(tr * face.bounds.center) <= 0)
end

#ALGO: Calculate the Scale length for scaling
def scale_length
	@size_scale_pix = @view.pixels_to_model(@scale_pix, @center3d) / @zoom_factor
	@text_scale_pix = G6.format_length_general @size_scale_pix
	w, = G6.simple_text_size @text_scale_pix
	@pt_text_norminal_pix = @center_scale_pix.offset X_AXIS, -w/2
end

#ALGO: Compute Reference parameters based on zoom factor
def adjust_pix
	#Distance between picks in pixel
	if @zoom_factor <= 2
		@pix2 = 8
	elsif @zoom_factor <= 5
		@pix2 = 7
	elsif @zoom_factor <= 10
		@pix2 = 4
	elsif @zoom_factor <= 20
		@pix2 = 3
	elsif @zoom_factor < 40
		@pix2 = 2
	else
		@pix2 = 1
	end	
	@pix = 2 * @pix2
	
	#Factor for face extension
	if @zoom_factor <= 4
		@nextend = 20
	elsif @zoom_factor < 10
		@nextend = 10
	elsif @zoom_factor < 40
		@nextend = 3
	else
		@nextend = 2
	end		
end

#ALGO: Change the zoom factor (value, :minus or :plus)
def set_zoom_factor(factor)
	case factor
	when :max
		factor = @zoom_range.last
	when :min
		factor = @zoom_range.first
	when :plus
		factor = nil
		@zoom_range.each_with_index do |val, i|
			if @zoom_factor < val
				factor = @zoom_range[i]
				break
			end	
		end
		factor = @zoom_range.last unless factor
	
	when :minus
		factor = nil
		@zoom_range.each_with_index do |val, i|
			if @zoom_factor < val
				factor = (i > 1) ? @zoom_range[i-2] : @zoom_range.first
				break
			end	
		end
		factor = @zoom_range[-2] unless factor
	end
	
	#Checking boundaries
	factor = @zoom_factor_min if factor < @zoom_factor_min
	factor = @zoom_factor_max if factor > @zoom_factor_max
	
	#Factor is unchanged
	return if @zoom_factor == factor
	
	#Setting the new factor
	zoom_factor_prev = @zoom_factor	
	@zoom_factor = factor
	@zoom_factor_last = @zoom_factor
	
	#Adjusting the reference parameters
	adjust_pix
	
	#Checking if zoom is performed from the Palette window
	if (@frozen || !@glass_mode) && edition_mouse_within?
		@zoom_by = zoom_factor_prev
		edition_zoom_by
	end
	
	#Updating the display
	camera_changed
end

#Round the zoom factor given a value
def round_zoom_factor(zoom_factor)
	factor = nil
	@zoom_range.each_with_index do |val, i|
		if zoom_factor < val
			factor = @zoom_range[i]
			break
		end	
	end
	factor = @zoom_range.last unless factor
	factor
end

#ALGO: Compute the auto zoom factor
def zoom_auto_compute
	return nil unless @zoom_auto && @notify_proc && (@ip.vertex || @ip.edge)
	
	d = @notify_proc.call(:zoom_auto, @ip.vertex, @ip.edge)
	return nil unless d
	
	#Handling the Auto zoom
	size = @view.pixels_to_model(@pix_auto, @ip.position)
	d2 = d.to_f
	zoom_auto_factor = size / d
	round_zoom_factor(zoom_auto_factor)
end

#-----------------------------------------------------------
#-----------------------------------------------------------
# EDITION: Manage edition in the glass box palette
#-----------------------------------------------------------
#-----------------------------------------------------------

#----------------------------------------------------
# EDITION: General methods for handling edition
#----------------------------------------------------

#EDITION: Check if the mouse is within the frozen zone
def edition_mouse_within?
	return false unless @xmove
	@palette.mouse_within_button?(@palette_zone_button, @xmove, @ymove)
end

#EDITION: Locate the 2D point for a vertex, edge or face
def edition_locate_object(dx, dy, x, y)
	return nil unless @magni_stack_inv && @magni_stack_inv.length > 0
	ptmid = Geom::Point3d.new(0.5 * dx, 0.5 * dy, 0)
	vec = @glass_center2d.vector_to ptmid
	t = Geom::Transformation.scaling(ptmid, 1, -1, 1) * Geom::Transformation.translation(vec)
	pix = 6
	ptxy = t.inverse * Geom::Point3d.new(x, y, 0)
	lobjects = @magni_stack_inv
	
	#Finding a face
	cur_parent = cur_tr = nil
	face_info = nil
	iface = nil
	lobjects.each_with_index do |obj, i|
		type, e, llpt, tr, parent = obj
		if e.class == Sketchup::Face
			llpt.each do |pts|
				if Geom.point_in_polygon_2D(ptxy, pts, true)
					face_info = [e, pts]
					cur_parent = parent
					cur_tr = tr
					iface = i
					break
				end	
			end	
		end
		break if iface
	end
	
	#Finding an edge
	edge_info = nil
	iedge = nil
	d_edge = nil
	lobjects.each_with_index do |obj, i|
		type, e, pts, tr, parent = obj
		break if iface && i >= iface
		next if cur_parent && parent != cur_parent
		if e.class == Sketchup::Edge
			d, pt, pt2 = G6.proximity_point_segment(ptxy, pts[0], pts[1])
			if d <= pix && (!d_edge || d < d_edge)
				edge_info = [e, pts]
				d_edge = d
				cur_parent = parent
				cur_tr = tr
				iedge = i
			end	
		end
		break if iedge
	end

	#Finding a fake edge
	unless edge_info
		edge_info = nil
		iedge = nil
		d_edge = nil
		lobjects.each_with_index do |obj, i|
			type, e, pts, tr, parent = obj
			break if iface && i >= iface
			next if cur_parent && parent != cur_parent
			if (e.class == String && e =~ /\Aedge/)
				d, pt, pt2 = G6.proximity_point_segment(ptxy, pts[0], pts[1])
				if d <= pix && (!d_edge || d < d_edge)
					edge_info = [e, pts]
					d_edge = d
					cur_parent = parent
					cur_tr = tr
					iedge = i
				end	
			end
			break if iedge
		end
	end
	
	#No face and edge found
	return nil unless face_info || edge_info
	
	#Finding the vertex if an edge is found
	if edge_info
		vertex_info = nil
		edge = edge_info[0]
		if edge.class == Sketchup::Edge
			d_vx = nil
			lobjects.each_with_index do |obj, i|
				type, e, pts, tr, parent = obj
				next unless e.class == Sketchup::Vertex
				break if i >= iedge
				next unless e == edge.start || e == edge.end
				d = ptxy.distance pts
				if d <= pix && (!d_vx || d < d_vx)
					vertex_info = [e, pts]
				end	
			end
		end	
	end
	
	#Returning the result
	[face_info, edge_info, vertex_info, cur_parent, cur_tr]
end

#EDITION: Handle events in the frozen glass
def edition_dispatch_event_zero ; edition_dispatch_event(*@edition_event_last) ; end
def edition_dispatch_event(code, button_down, dx, dy, x, y)
	#Go to Frozen mode if not yet frozen
	@edition_event_last = [:move, button_down, dx, dy, x, y].clone
	unless @frozen
		return unless code == :button_down
		toggle_freeze
		return
	end
	
	#Registering the event
	@edition_event_down = [code, button_down, dx, dy, x, y].clone if code == :button_down
	@edition_active = button_down
	
	#Locate the mouse within the glass window
	location_info = [dx, dy, x, y]
	@pick_info_cur = pick_info = edition_locate_object(dx, dy, x, y)
	@edition_instructions = []
	@highlighted_edges = {}
	@selected_repairs = {}
	@ignored_repairs = {}
	
	#Dispatch based on tool
	case @edition_tool
	when :select
		edition_select_main(code, button_down, location_info, pick_info)
	when :eraser	
		edition_eraser_main(code, button_down, location_info, pick_info)
	when :tape
		edition_tape_main(code, pick_info, location_info)
	when :move
		edition_move_main(code, pick_info, location_info)
	when :repair
		edition_repair_main(true, code, button_down, location_info, pick_info)
	when :ignore
		edition_repair_main(false, code, button_down, location_info, pick_info)
	end	
end

#EDITION: Handle escape
def edition_handle_escape
	case @edition_tool
	when :tape
		edition_tape_reset
	when :move
		edition_move_reset
	else
		false
	end
end

#EDITION: Reset varibale of tools
def editon_reset_env
	@edition_panning = false
	@tape_mouse_down = nil
	@tape_pt3d_down = nil
	@move_mouse_down = nil
	@ent_eraser_down = nil
end

#EDITION: Perform an undo action
def edition_undo
	if @notify_proc
		@notify_proc.call :undo
	else
		Sketchup.undo
		handle_undo
	end
end

#EDITION: Check if dragging down for Pan feature
def edition_dragging_down?(location_info)
	code, button_down, dx, dy, x, y = @edition_event_last
	return false unless button_down
	code, button_down, dx, dy, xdown, ydown = @edition_event_down
	status = ((x - xdown).abs > 2 || (y - ydown).abs > 2)
	return false unless status
	
	#Starting or continuing the panning
	if @edition_panning
		edition_panning_move(location_info)
	else
		edition_panning_start(location_info)
	end	
	true
end

#EDITION: Cursor depending on the edition tool
def edition_cursor
	return nil unless @frozen
	return @id_cursor_pan if @edition_panning
	case @edition_tool
	when :select
		shift = (@notify_proc && @notify_proc.call(:shift_down))
		ctrl = (@notify_proc && @notify_proc.call(:ctrl_down))
		if ctrl && shift
			id = @id_cursor_select_minus
		elsif shift
			id = @id_cursor_select_plusminus
		elsif ctrl
			id = @id_cursor_select_plus
		else
			id = @id_cursor_select
		end
	when :tape
		id = @id_cursor_tape
	when :move
		id = @id_cursor_move
	when :eraser
		id = @id_cursor_eraser
	when :pencil
		id = @id_cursor_pencil
	when :repair
		id = @id_cursor_repair
	when :ignore
		id = @id_cursor_ignore
	else
		id = 0
	end	
	id
end

#EDITION: Notify of a change of view or zoom factor
def edition_notify_change
	return unless @frozen
	case @edition_tool
	when :tape
		edition_tape_changing
	when :move
		edition_move_changing
	else
		return
	end	
	edition_dispatch_event_zero
end

#EDITION: Set current tool
def edition_set_tool(tool)
	@selection.clear if @edition_tool == :move
	tool = :select if tool == @edition_tool
	@edition_tool = tool
	editon_reset_env
	if tool == :unselect
		@selection.clear
		@edition_tool = :select
		onMouseMove_zero
	elsif tool == :move
		@move_selection_on = (@selection.length > 0)
	end	
end

#EDITION: Compute color based on originating entity
def edition_color_by_entity(code)
	case code
	when :vertex
		'green'
	when :edge
		'red'
	when :face
		'blue'
	else
		'black'
	end	
end

#EDITION: Compute the 3D point for a given 2D point information
def edition_coords3D(mouse_info)
	pt2d, code, e, tr, info = mouse_info
	
	#Vertex
	return tr * e.position if code == :vertex

	#Point in viewport. Convoluted algo because pickray is not precise enough
	pt2c = @tr2d_magni_inv * pt2d
	ray = [@eye, @eye.vector_to(get_point3d_from_2d(pt2c, @center3d))]
	
	pt3d = nil
	case code
	when :edge
		if e.class == String
			line = info[1].collect { |pt| tr * pt }
		else
			line = [tr * e.start.position, tr * e.end.position]
		end	
		lpt = Geom.closest_points line, ray
		pt3d = lpt.first if lpt		
	when :face
		plane = [tr * e.vertices[0].position, G6.transform_vector(e.normal, tr)]
		pt3d = Geom.intersect_line_plane ray, plane
	else
		plane = [@center3d, @view.camera.direction]
		pt3d = Geom.intersect_line_plane ray, plane	
	end

	pt3d
end

#EDITION: Calculate the mouse information based on inferences
def edition_mouse_inference(pick_info, location_info, just_edge=false)
	dx, dy, x, y = location_info
	face = edge = vertex = nil
	face_info, edge_info, vertex_info, parent, tr = pick_info
	face = face_info.first if face_info
	edge = edge_info.first if edge_info
	vertex = vertex_info.first if vertex_info
	
	#Inference for current point
	ptmid = Geom::Point3d.new 0.5 * dx, 0.5 * dy, 0
	vec = @glass_center2d.vector_to ptmid
	t = Geom::Transformation.scaling(ptmid, 1, -1, 1) * Geom::Transformation.translation(vec)
	ptxy = t.inverse * Geom::Point3d.new(x, y, 0)
	
	if vertex
		mouse_info = [vertex_info[1], :vertex, vertex, tr]
	elsif edge && (!just_edge || edge.instance_of?(Sketchup::Edge))
		mouse_info = [ptxy.project_to_line(edge_info[1]), :edge, edge, tr, edge_info]
	else
		mouse_info = [ptxy, ((face) ? :face : nil), face, tr, face_info]
	end	
	mouse_info
end

#EDITION: Compute the instruction for a repair tooltip if applicable
def edition_tooltip_repair(ptmouse, lent)
	lent.each do |e|
		next unless e
		tipinfo = (@notify_proc) ? @notify_proc.call(:tooltip_repair, e) : nil
		if tipinfo
			tip, bkcolor, frcolor = tipinfo
			lgl = G6.rectangle_text_instructions(tip, ptmouse.x, ptmouse.y, bkcolor, frcolor, 1)
			@edition_instructions.concat lgl
		end
	end
end

#EDITION: Create the instruction for a point based on inference
def edition_instructions_point(mouse_info)
	pt, where = mouse_info
	frcolor = 'lightgrey'
	case where
	when :vertex
		pts = G6.pts_circle pt.x, pt.y, 5, 12
		color = 'green'
		frcolor = 'black'
	when :edge
		pts = G6.pts_square pt.x, pt.y, 4
		color = 'red'
	when :face
		pts = G6.pts_circle pt.x, pt.y, 4, 4
		color = 'blue'
	else
		pts = G6.pts_square pt.x, pt.y, 2
		color = 'black'
	end
	[[GL_POLYGON, pts, color], [GL_LINE_LOOP, pts, frcolor, 1, '']]
end


#EDITION: Prepare an operation
def edition_before_operation(op_symb)
	text = @hsh_ops_titles[op_symb]
	if @notify_proc
		@notify_proc.call :before_operation, text
	else
		@suops.set_title text
		@suops.start_operation
	end
end

#EDITION: Commit an operation
def edition_after_operation
	if @notify_proc
		@notify_proc.call :after_operation
	else
		@suops.commit_operation
	end
end

#EDITION: Commit an operation
def edition_abort_operation
	if @notify_proc
		@notify_proc.call :abort_operation
	else
		@suops.abort_operation
	end
end

def edition_entity_under_mouse(pick_info)
	face = edge = vertex = nil
	face_info, edge_info, vertex_info, parent, tr = pick_info
	face = face_info.first if face_info
	edge = edge_info.first if edge_info
	vertex = vertex_info.first if vertex_info
	[vertex, edge, face].find { |e| e }
end

#----------------------------------------------------
# EDITION_SELECTION: SU Selection management
#----------------------------------------------------

def su_selection_add(le, tr)
	@hsh_tr_by_entity = {} unless @hsh_tr_by_entity
	le = [le] unless le.class == Array
	le.each { |e| @hsh_tr_by_entity[e.entityID] = tr }
	@selection.add le
end

def su_selection_clear
	@hsh_tr_by_entity = {}
	@selection.clear
end

#----------------------------------------------------
# EDITION_SELECT: Select tool
#----------------------------------------------------

#EDITION_SELECT: Handle the SELECT tool
def edition_select_main(code, button_down, location_info, pick_info)
	mouse_info = edition_mouse_inference(pick_info, location_info)
	ptmouse, = mouse_info
	
	face = edge = vertex = nil
	face_info, edge_info, vertex_info, parent, tr = pick_info
	face = face_info.first if face_info
	edge = edge_info.first if edge_info
	vertex = vertex_info.first if vertex_info
	
	shift = ctrl = false
	if @notify_proc
		shift = @notify_proc.call(:shift_down)
		ctrl = @notify_proc.call(:ctrl_down)
	end
	
	#Tooltip for repair
	edition_tooltip_repair ptmouse, [vertex, edge, face]
	edge = nil unless edge.class == Sketchup::Edge
	
	case code
	when :button_down
		@down_received = true
		
	when :button_up, :long_click	
		return edition_panning_stop if @edition_panning
		return unless @down_received
		@down_received = false
		ls_add = []
		ls_remove = []
		e = [edge, face].find { |a| a }
		
		#No entity selected
		if !e
			unless shift || ctrl
				su_selection_clear
				refresh_decoration
			end
			return
		end
		
		#Triple click
		if @time_edit_move_double_click && Time.now - @time_edit_move_double_click < 0.4
			if @selection.include?(e)
				su_selection_clear unless shift || ctrl
				su_selection_add e.all_connected, tr
			else	
				su_selection_clear unless shift || ctrl
				@selection.remove e.all_connected if shift
			end	
			
		#Selection / Unselection	
		else
			if @selection.include?(e)
				if @selection.length == 1 
					@selection.remove e unless ctrl
				elsif shift
					@selection.remove e
				elsif !ctrl	
					su_selection_clear unless shift || ctrl
					su_selection_add e, tr
				end	
			else
				su_selection_clear unless shift || ctrl
				su_selection_add e, tr
			end	
		end	
		refresh_decoration
		
	when :move
		unless edition_dragging_down?(location_info)
			if edge
				@highlighted_edges[edge.entityID] = (@selection.include?(edge)) ? @su_selection_color : @color_highlight_edge
			end	
			refresh_decoration
		end
		
	when :out
	
	when :double_click
		@time_edit_move_double_click = Time.now
		if edge
			add_ent = [edge] + edge.faces
		elsif face
			add_ent = [face] + face.edges
		else
			add_ent = nil
		end	
		
		if add_ent
			if !@selection.include?(add_ent[0]) && shift
				@selection.remove add_ent
			else
				su_selection_clear unless shift || ctrl
				su_selection_add add_ent, tr
			end	
		end		
		refresh_decoration
	end
end

#EDITION: Explode the curve attached to an edge
def edition_explode_curve(edge)
	return unless edge.valid? && edge.curve
	
	#Performing the erasing of edges
	edition_before_operation(:explode_curve)
	edge.explode_curve
	edition_after_operation
	
	#Refreshing the glass
	camera_execute_change
end

#EDITION: Try to make faces from an edge
def edition_make_face(edge)
	return unless edge.valid?
	
	#Performing the erasing of edges
	nbfaces = edge.faces.length
	edition_before_operation(:make_face)
	edge.find_faces
	if edge.faces.length == nbfaces
		edition_abort_operation	
	else
		edition_after_operation
		camera_execute_change
	end	
end

#----------------------------------------------------
# EDITION PAN: Panning mode
#----------------------------------------------------

#EDITION PAN: Start the panning
def edition_panning_start(location_info)
	@edition_panning = true
	dx, dy, @x_panning, @y_panning = location_info
	@center2d_panning = @center2d
end

#EDITION PAN: Stop the panning
def edition_panning_stop
	@edition_panning = false
end

#EDITION PAN: Manage the panning when mouse moves
def edition_panning_move(location_info)
	@edition_panning = true
	dx, dy, x, y = location_info
	
	#Computing the new centers in 2D and 3D
	edition_shift(@x_panning, @y_panning, x, y, @zoom_factor, @center2d_panning)
		
	#Refreshing the view at new position
	onMouseMove(0, @center2d.x, @center2d.y, @view)
end

#EDITION PAN: Compute the new centers when a point in glass is shifted from (x0, y0) to (x1, y1)
def edition_shift(x0, y0, x1, y1, zoom_factor, center_origin2d)
	deltax = x1 - x0
	deltay = y1 - y0
	return unless deltax.abs > 2 || deltay.abs > 2
	
	#Shift in 2D and computing new center in 2D
	deltax /= 1.0 * zoom_factor
	deltay /= 1.0 * zoom_factor
	oldc2d = @center2d
	@center2d = Geom::Point3d.new(center_origin2d.x - deltax, center_origin2d.y + deltay, 0)
	
	#Computing the new center 3D
	@center3d = get_point3d_from_2d @center2d, @center3d
end

#EDITION: Perform a Zoom by the current point in the palette glass window
def edition_zoom_by
	code, button_down, dx, dy, x0, y0 = @edition_event_last
	xmid = 0.5 * dx
	ymid = 0.5 * dy
	edition_shift(x0, y0, xmid, ymid, @zoom_by, @center2d)
	edition_shift(xmid, ymid, x0, y0, @zoom_factor, @center2d)	
end

#----------------------------------------------------
# EDITION TAPE: Tape measure tool
#----------------------------------------------------

#EDITION TAPE: notification when view is changed or zoomed and tape tool is active
def edition_tape_changing
	return unless @tape_mouse_down
	newpt = @tr2d_magni * get_screen_coords(@tape_pt3d_down)
	@tape_mouse_down[0] = newpt
	@tape_pt3d_down = edition_coords3D(@tape_mouse_down)
	@tape_mouse_down = nil unless Geom.point_in_polygon_2D(newpt, @glass_box2d, true)
end

#EDITION TAPE: notification when escape is pressed
def edition_tape_reset
	if @tape_mouse_down
		@tape_mouse_down = nil
		@tape_pt3d_down = nil
		edition_dispatch_event_zero
		return true
	end
	false
end

#EDITION TAPE: Handle the TAPE tool
def edition_tape_main(code, pick_info, location_info)
	mouse_info = edition_mouse_inference(pick_info, location_info, true)
	ptmouse, = mouse_info
	
	shift = ctrl = false
	if @notify_proc
		shift = @notify_proc.call(:shift_down)
		ctrl = @notify_proc.call(:ctrl_down)
	end
	
	case code
	when :button_down
		@tape_mouse_down = (@tape_mouse_down) ? nil : mouse_info
		@tape_pt3d_down = edition_coords3D(mouse_info) if @tape_mouse_down

	when :button_up, :long_click
		return edition_panning_stop if @edition_panning
		if @tape_mouse_down
			ptdown = @tape_mouse_down[0]
			if (ptdown.x - ptmouse.x).abs > 3 || (ptdown.y - ptmouse.y).abs > 3
				@tape_mouse_down = nil 
			end	
		end		

	when :move
		if (shift || ctrl || @enable_panning_tape_move) && edition_dragging_down?(location_info)
			@tape_mouse_down = @tape_mouse_move = nil
		else
			@tape_mouse_move = mouse_info
		end	
		
	when :out
	
	when :double_click

	end
	
	#Calculating the instructions with the distance
	@edition_instructions.concat edition_instructions_point(@tape_mouse_move) if @tape_mouse_move
	if @tape_mouse_down
		@tape_pt3d_down = edition_coords3D(@tape_mouse_down)
		ptdown = @tape_mouse_down.first
		if ptdown != ptmouse
			d = nil
			@edition_instructions.concat edition_instructions_point(@tape_mouse_down)
			
			#For edges, draw a parallel
			if @tape_mouse_down[1] == :edge
				pt3d = edition_coords3D(mouse_info)
				return unless pt3d
				edge = @tape_mouse_down[2]
				tr = @tape_mouse_down[3]
				if edge.class == Sketchup::Edge
					line3d = [tr * edge.start.position, tr * edge.end.position]	
				else
					line3d = @tape_mouse_down[4][1].collect { |pt| tr * pt }
				end	
				vec3d = line3d.first.vector_to line3d.last
				pt23d = pt3d.offset vec3d
				if pt3d.on_line?(line3d)
					d = pt3d.distance @tape_pt3d_down
					ptproj3d = @tape_pt3d_down
				else
					d = pt3d.distance_to_line line3d if pt3d
					ptproj3d = @tape_pt3d_down.project_to_line [pt3d, pt23d]
				end
				ptproj = @tr2d_magni * get_screen_coords(ptproj3d)
				pt2 = @tr2d_magni * get_screen_coords(pt23d)
				vec = ptmouse.vector_to(pt2)
				px = @dx * 2
				ptmouse1 = ptproj.offset vec, px
				ptmouse2 = ptproj.offset vec, -px
				line = [ptmouse1, ptmouse2]
				line_info = G6.clip2d_rect_segment(line, @glass_box2d)
				if line_info
					line = [line_info[0][0], line_info[1][0]]
					@edition_instructions.push [GL_LINE_STRIP, line, 'black', 1, '_']
				end	
				
			#For other cases distance is point to point	
			else
				ptproj = ptmouse
				pt3d = edition_coords3D(mouse_info)
				d = pt3d.distance @tape_pt3d_down if pt3d
			end	
			
			#Instructions for arrow and text label
			color = edition_color_by_entity @tape_mouse_down[1]
			@edition_instructions.concat G6.arrow_2D_instructions([ptdown, ptproj], :end_open, color, 2, '')
			if d	
				text = G6.format_length_general(d)
				lgl = G6.rectangle_text_instructions(text, ptmouse.x, ptmouse.y, 'lightgreen', 'green', 1)
				@edition_instructions.concat lgl
			end	
		end	
	end
	
	instructions_after
	@view.invalidate
	#refresh_decoration
end

#----------------------------------------------------
# EDITION MOVE: MOVE tool
#----------------------------------------------------

#EDITION MOVE: notification when view is changed or zoomed and Move tool is active
def edition_move_changing
	return unless @move_mouse_down
	newpt = @tr2d_magni * get_screen_coords(@move_pt3d_down)
	@move_mouse_down[0] = newpt
	@move_pt3d_down = edition_coords3D(@move_mouse_down)
	@move_mouse_down = nil unless Geom.point_in_polygon_2D(newpt, @glass_box2d, true)
end

#EDITION MOVE: notification when escape is pressed
def edition_move_reset
	if @move_mouse_down
		@move_mouse_down = nil
		edition_dispatch_event_zero
		return true
	end
	false
end

#EDITION MOVE: Handle the MOVE tool events
def edition_move_main(code, pick_info, location_info)
	mouse_info = edition_mouse_inference(pick_info, location_info, true)
	ptmouse, = mouse_info

	shift = ctrl = false
	if @notify_proc
		shift = @notify_proc.call(:shift_down)
		ctrl = @notify_proc.call(:ctrl_down)
	end
	
	case code
	when :button_down
		if @move_mouse_down
			edition_move_execute(mouse_info)
		else
			@move_mouse_down = mouse_info
		end	
		@move_pt3d_down = edition_coords3D(mouse_info) if @move_mouse_down

	when :button_up, :long_click
		return edition_panning_stop if @edition_panning
		if @move_mouse_down
			ptdown = @move_mouse_down[0]
			if (ptdown.x - ptmouse.x).abs > 3 || (ptdown.y - ptmouse.y).abs > 3
				edition_move_execute(mouse_info)
			end
		end		

	when :move
		if (shift || ctrl || @enable_panning_tape_move) && edition_dragging_down?(location_info)
			@move_mouse_down = @move_mouse_move = nil
		else
			@move_mouse_move = mouse_info
			if !@move_selection_on && !@move_mouse_down
				e = mouse_info[2]
				tr = mouse_info[3]
				su_selection_clear
				if e.class == Sketchup::Edge || e.class == Sketchup::Face
					su_selection_add e, tr
				end	
				refresh_decoration
			end
		end
		
	when :out
	
	when :double_click

	end
	
	#Calculating the instructions for the arrow
	@edition_instructions.concat edition_instructions_point(@move_mouse_move) if @move_mouse_move
	if @move_mouse_down
		ptdown = @move_mouse_down.first
		if ptdown != ptmouse
			@edition_instructions.concat edition_instructions_point(@move_mouse_down)
			ptproj = ptmouse
			pt3d = edition_coords3D(mouse_info)
			
			#Instructions for arrow and text label
			color = edition_color_by_entity @move_mouse_down[1]
			@edition_instructions.concat G6.arrow_2D_instructions([ptdown, ptproj], :end_open, color, 2, '')
			tooltip, color = edition_move_tooltip
			lgl = G6.rectangle_text_instructions(tooltip, ptmouse.x, ptmouse.y, color, 'gray')
			@edition_instructions.concat lgl
		end	
	end
	
	instructions_after
	@view.invalidate
end

#EDITION MOVE: Perform the move of entities
def edition_move_execute(mouse_info)
	entity = @move_mouse_down[2]
	tr = @move_mouse_down[3]
	@move_mouse_down = nil

	#Vector for moving in absolute space
	ptm1 = @move_pt3d_down
	ptm2 = edition_coords3D(mouse_info)
	return if ptm1 == ptm2
	
	vec_move = ptm1.vector_to ptm2

	#Performing the erasing of edges
	edition_before_operation(:move)
	
	#Exploring the selection
	if @selection.length > 0
		hentities = {}
		@selection.each do |e|
			entities = G6.grouponent_entities(e.parent)
			entities_id = entities.object_id
			lst = hentities[entities_id]
			lst = hentities[entities_id] = [entities] unless lst
			lst.push e
		end
		@selection.clear
		hentities.each do |id, lst|
			tr = @hsh_tr_by_entity[lst[1].entityID]
			vec = tr.inverse * vec_move
			t = Geom::Transformation.translation(vec)
			lst[0].transform_entities t, lst[1..-1] 
		end	
		
	#No selection, but a vertex is taken as origin
	elsif entity.class == Sketchup::Vertex
		vec = tr.inverse * vec_move
		t = Geom::Transformation.translation(vec)
		entities = G6.grouponent_entities(entity.parent)
		entities.transform_entities t, [entity] 
	end
	
	#Refreshing the glass
	edition_after_operation
	camera_execute_change
end

#EDITION MOVE: Compute the tooltip
def edition_move_tooltip
	text = @prefix_move
	txadd = nil
	if @move_selection_on
		txadd = @tip_selection
		color = 'yellow'
	else
		case @move_mouse_down[1]
		when :vertex
			txadd = @tip_vertex
			color = 'lightgreen'
		when :edge
			txadd = @tip_edge
			color = 'pink'
		when :face
			txadd = @tip_face
			color = 'lightblue'
		end	
	end	
	text += ' ' + txadd if txadd
	[text, color]
end

#----------------------------------------------------
# EDITION ERASER: Eraser tool
#----------------------------------------------------

#EDITION ERASER: Handle the ERASER tool
def edition_eraser_main(code, button_down, location_info, pick_info)
	face = edge = vertex = nil
	face_info, edge_info, vertex_info, parent, tr = pick_info
	face = face_info.first if face_info
	edge = edge_info.first if edge_info
	edge = nil unless edge.instance_of?(Sketchup::Edge)
	vertex = vertex_info.first if vertex_info
	
	case code
	when :button_down
		@ent_eraser_down = [vertex, edge].find { |a| a }
		if @ent_eraser_down
			ledges = (vertex) ? vertex.edges : [edge]
			ledges.each { |e| @highlighted_edges[e.entityID] = @color_eraser_edge }
			refresh_decoration
		end	
	
	when :button_up, :long_click
		return edition_panning_stop if @edition_panning
		return unless @ent_eraser_down
		ent_cur = [vertex, edge].find { |a| a }
		return if ent_cur != @ent_eraser_down
		edition_eraser_execute ent_cur
				
	when :move
		unless !@ent_eraser_down && edition_dragging_down?(location_info)
			ent_cur = [vertex, edge].find { |a| a }
			if ent_cur && (!button_down || ent_cur == @ent_eraser_down)
				ledges = (vertex) ? vertex.edges : [edge]
				color = (button_down && ent_cur == @ent_eraser_down) ? @color_eraser_edge : @color_highlight_edge
				ledges.each { |e| @highlighted_edges[e.entityID] = color }
			end	
			refresh_decoration
		end
		
	when :out
	
	end
end

#EDITION ERASER: Execute the erasing of edges
def edition_eraser_execute(ent)
	#Computing the edges to be deleted
	if ent.class == Sketchup::Vertex
		ledges = ent.edges
	else
		ledges = [ent]
	end
	entities = G6.grouponent_entities(ent.parent)
	
	#Performing the erasing of edges
	edition_before_operation(:eraser)
	entities.erase_entities ledges
	edition_after_operation
	
	#Refreshing the glass
	camera_execute_change
end

#----------------------------------------------------
# EDITION REPAIR: Repair and Ignore tool
#----------------------------------------------------

#EDITION REPAIR: Handle the REPAIR and IGNORE tool
def edition_repair_main(flg_repair, code, button_down, location_info, pick_info)
	mouse_info = edition_mouse_inference(pick_info, location_info)
	ptmouse, = mouse_info
	face = edge = vertex = nil
	face_info, edge_info, vertex_info, parent, tr = pick_info
	face = face_info.first if face_info
	edge = edge_info.first if edge_info
	vertex = vertex_info.first if vertex_info

	#Tooltip for repair
	edition_tooltip_repair ptmouse, [vertex, edge, face]
	
	case code
	when :button_down
		@ent_repair_down = [vertex, edge, face].find { |a| a }
		if @ent_repair_down
			@lent_repairs = edition_repair_check @ent_repair_down
			@ent_repair_down = nil unless @lent_repairs
		end	
	
	when :button_up, :long_click
		return edition_panning_stop if @edition_panning
		return unless @ent_repair_down
		ent_cur = [vertex, edge, face].find { |a| a }
		return if ent_cur != @ent_repair_down
		edition_repair_execute((flg_repair) ? :repair_now : :ignore)
				
	when :move
		unless !@ent_repair_down && edition_dragging_down?(location_info)
			ent_cur = [vertex, edge, face].find { |a| a }
			@lent_repairs = nil
			if ent_cur
				@lent_repairs = edition_repair_check ent_cur
				if @lent_repairs
					if flg_repair
						@lent_repairs.each { |e| id = (e.class == String) ? e : e.entityID ; @selected_repairs[id] = e }
					else
						@lent_repairs.each { |e| id = (e.class == String) ? e : e.entityID ; @ignored_repairs[id] = e }
					end	
				end
			end	
			refresh_decoration
		end
	
	end
end

#EDITION REPAIR: Check the reparations at an entity
def edition_repair_check(ent)
	return nil unless @notify_proc
	repair_info = @notify_proc.call :is_repair, ent
	
	#Reparation found
	return repair_info.first if repair_info
	
	#Entity is vertex. Looking for reparation among its edges
	lent = []
	if ent.class == Sketchup::Vertex
		ent.edges.each do |e|
			repair_info = @notify_proc.call :is_repair, e
			lent.concat repair_info.first if repair_info
		end
	end
	(lent.empty?) ? nil : lent
end

#EDITION REPAIR: Execute the repairing or the marking for ignoring
def edition_repair_execute(code)
	@selected_repairs = {}
	@ignored_repairs = {}
	
	lrepair_info = []
	@lent_repairs.each do |e|
		next if e.class == String
		repair_info = @notify_proc.call :is_repair, e
		lrepair_info.push repair_info unless lrepair_info.include?(repair_info)
	end
	@notify_proc.call code, lrepair_info unless lrepair_info.empty?
	
	if code == :ignore
		refresh_decoration
	else	
		camera_execute_change
	end	
end

#-------------------------------------------
# VIEW: View change management
#-------------------------------------------

#VIEW: Notification of view changed
def onViewChanged(view)
	return unless @magnifier_on
	resume view, false
end

#VIEW: Start of a change of view (Zoom or Orbit)
def suspend(view)
	@cur_camera = G6.camera_duplicate(view.camera)
	@view_direction = view.camera.direction
	@view_target = view.camera.target
	@eye_ref = view.camera.eye
end

#VIEW: End of a change of view
def resume(view, ctrl_down)
	return unless @magnifier_on

	#Zoom magnifier rather than zoom view
	if (ctrl_down || edition_mouse_within?) && @cur_camera && view.camera.direction.samedirection?(@view_direction) && view.camera.target != @view_target
		vec = @eye_ref.vector_to view.camera.eye
		factor = (vec.valid? && vec % view.camera.direction > 0) ? :plus : :minus
		@view.camera = @cur_camera
		set_zoom_factor factor
	else	
		@orbiting = true
		camera_changed
	end	
end

#VIEW: Refresh the glass viewport after changes
def refresh_decoration
	instructions_before
	magnify_stack_decorate
	instructions_after
	@view.invalidate
end

#-------------------------------------------
# MOVE: Picking and hovering Faces and Edges
#-------------------------------------------

#MOVE: Determine the best cursor position
def cursor_position(ip, x, y, view)
	dof = ip.degrees_of_freedom
	position = nil
	if dof < 2 && !ip.vertex && !ip.edge && ip.face
		face, edge, tr, parent = hover_under_mouse(0, x, y, view)
		if face
			plane = [tr * face.vertices[0].position, G6.transform_vector(face.normal, tr)]
			position = Geom.intersect_line_plane view.pickray(x, y), plane
		end	
		dof = 2
	end
	position = ip.position unless position

	@ip_used = (dof == 0)
	view.tooltip = (@ip_used) ? ip.tooltip : ''
	position
end

#MOVE: Manage actions on a mouse move
def onMouseMove_zero ; onMouseMove(0, @xmove, @ymove, @view) if @xmove ; end
def onMouseMove(flags, x, y, view)
	@xmove = x
	@ymove = y
	return unless @magnifier_on
		
	return if @moving
	
	#Calculate the points picked in 3D and 2D, unless the view is frozen
	unless @frozen || @edition_panning || @zoom_by
		@ip.pick view, x, y
		no_inference = @notify_proc && @notify_proc.call(:shift_down)
		if no_inference
			ray = view.pickray(x, y)
			@center3d = @eye.offset ray[1], @eye.distance(@ip.position)
			@ip_used = false
		else
			@center3d = cursor_position(@ip, x, y, view)
			if @center3d_last != @center3d
				@center3d_last = @center3d
				zf = zoom_auto_compute
				@zoom_factor = (zf) ? zf : @zoom_factor_last
			end	
		end
	end
	if (@orbiting || !@frozen) && !@edition_panning && !@zoom_by
		@center2d = view.screen_coords @center3d
		@center2d.z = 0
	end
	
	#Adjusting the box
	algo_compute_boxes
	algo_grid_picking(view, @center2d.x, @center2d.y)
	
	@moving = true
	@zoom_by = @orbiting = false
	
	true
end

#MOVE: Identify which objects (face and edge)  are under the mouse
def hover_under_mouse(flags, x, y, view)
	@ph.do_pick x, y
	
	ph_face = @ph.picked_face
	ph_edge = @ph.picked_edge
	elt = [ph_edge, ph_face].find { |a| a }

	#Finding the parent and transformation
	tr = @tr_id
	parent = nil
	return nil unless elt
	for i in 0..@ph.count
		ls = @ph.path_at(i)
		if ls && ls.include?(elt)
			parent = ls[-2]
			tr = @ph.transformation_at(i)
			break
		end
	end	
	tr = @tr_id unless tr
	parent = @model unless parent
	[ph_face, ph_edge, tr, parent]
end

#---------------------------------------------------------------------------------------------
# DRAW: Methods to manage drawing
#---------------------------------------------------------------------------------------------

#DRAW: Update the status bar message
def message_update
	Sketchup.set_status_text @text_message_label, SB_VCB_LABEL
	Sketchup.set_status_text "#{@zoom_factor}", SB_VCB_VALUE
	Sketchup.set_status_text @text_message_bar
end

def message_clear
	Sketchup.set_status_text '', SB_VCB_LABEL
	Sketchup.set_status_text '', SB_VCB_VALUE
	Sketchup.set_status_text ''
end

#DRAW: Top method for drawing in the viewport
def draw(view)
	return false unless @magnifier_on
	draw_component(view, @parent) if @parent && @parent != @model
	
	draw_explore_box view
	if @glass_mode
		lgl = @instructions2d + @instructions2d_after
		@ogl.process_draw_GL(view, @tr_id, lgl)
	end
	@ip.draw view if @ip_used
	
	@moving = false

	true
end

#DRAW: draw the boundary box of a component
def draw_component(view, parent)
	return unless parent.valid?
	view.line_stipple = ''
	view.line_width = 1
	view.drawing_color = 'gray'
	llines = G6.grouponent_box_lines(view, parent, @tr, 10)
	view.draw GL_LINES, llines unless llines.empty?
end

#DRAW: Draw the exploration box
def draw_explore_box(view)
	if @capa_transparency
		view.drawing_color = @color_explore_box
		view.draw2d GL_POLYGON, @explore_box_display
	end	
	view.line_width = 3
	view.line_stipple = ''
	view.drawing_color = (@frozen) ? @color_glass_frame_frozen : @color_explorer_frame
	view.draw2d GL_LINE_LOOP, @explore_box_display
	#draw_explore_box_dots(view)
end

def draw_explore_box_dots(view)	
	view.drawing_color = 'red'
	@ls_grid.each do |pt|	
		pts = G6.pts_square pt.x, pt.y, 1
		view.draw2d GL_POLYGON, pts
	end
end

#DRAW: instructions before the geometry: background	
def instructions_before
	@instructions2d = []
	@instructions2d.push [GL_POLYGON, @glass_box2d, @su_background_color]
end
	
#DRAW: instructions after the geometry: Frame, zoom factor, scale	
def instructions_after
	@instructions2d_after = []

	#Frame and decoration of the glass window
	if @frozen
		color = @color_glass_frame_frozen
	else	
		color = (@zoom_factor && @zoom_factor != @zoom_factor_last) ? @color_glass_frame_auto : @color_glass_frame
	end	
	@instructions2d_after.push [GL_LINE_LOOP, @glass_frame2d, color, 3, '']
	
	@instructions2d_after.push ['T', @pt_text, "#{@zoom_factor.round}X"]
	if @text_scale_pix
		color = (@size_scale_pix < 1) ? 'red' : 'black'
		@instructions2d_after.push [GL_LINES, @lines_scale_pix, color, 1, '']
		@instructions2d_after.push ['T', @pt_text_norminal_pix, @text_scale_pix]
	end	
end
	
#DRAW: generate instructions for the palette	
def instructions_for_palette(symb, dx, dy, main_color, frame_color, selected, grayed)
	ptmid = Geom::Point3d.new 0.5 * dx, 0.5 * dy, 0
	vec = @glass_center2d.vector_to ptmid
	t = Geom::Transformation.scaling(ptmid, 1, -1, 1) * Geom::Transformation.translation(vec)
	instructions = []
	
	#Geometry
	instructions += @instructions2d

	#Final instruction for frame and decoration
	instructions += @instructions2d_after

	#Superimposed instructions from tools
	instructions += @edition_instructions if @edition_instructions

	lgl = []
	instructions.each do |a|
		code, pts, color, width, stipple = a
		pts = (code == 'T') ? t * pts : pts.collect { |pt| t * pt }
		lgl.push [code, pts, color, width, stipple]
	end
	lgl
end
	
#---------------------------------------------------------------------------------------------
# KEYBOARD: Keyboard management
#---------------------------------------------------------------------------------------------

#KEY: Return key pressed
def onReturn(view)
	return unless @magnifier_on
	toggle_freeze
end

#KEY: Handle Key down
def handle_key_down(key)
	case key			
	when VK_UP, 187, 190, 107
		set_zoom_factor :plus
	when VK_DOWN, 188, 109, 189	
		set_zoom_factor :minus
	when VK_RIGHT
		set_zoom_factor :max
	when VK_LEFT
		set_zoom_factor :min
	else
		return false
	end	
	true
end

#KEY: Key UP received
def handle_key_up(key)
	case key			
	when 9
		toggle_display_mode
	when VK_DELETE
		camera_execute_change
		return false
	else
		return false
	end	
	true
end

#VCB: Declare vcb formats
def init_VCB	
	@vcb = Traductor::VCB.new
	@vcb.declare_input_format :factor, "i"					#offset length
end

#VCB: Handle VCB input
def onUserText(text, view)
	return UI.beep unless @vcb
	nb_errors = @vcb.process_parsing(text)
	
	if nb_errors > 0
		lmsg = []
		@vcb.each_error { |symb, s| lmsg.push "<#{s}>" }
		msg = "#{T6[:T_ERROR_InVCB]} \"#{text}\"  --> #{lmsg.join(' - ')}"
		view.invalidate
	else
		action_from_VCB
	end	
end

#VCB: Execute the action
def action_from_VCB
	factor = nil
	@vcb.each_result do |symb, val, suffix|
		case symb
		when :factor
			factor = val
		end	
	end
	
	#Changing the offset
	if factor
		set_zoom_factor factor	
	end
end

#---------------------------------------------------------------------------------------------
# CLICK: Click management
#---------------------------------------------------------------------------------------------

#CLICK: Button click DOWN
def onLButtonDown(flags, x, y, view)
	@button_down = true
	@xdown = x
	@ydown = y
	return false unless @magnifier_on
	
	true
end

#CLICK: Button click UP
def onLButtonUp(flags, x, y, view)
	@xup = x
	@yup = y
	return true unless @button_down
	@button_down = false
	return false unless @magnifier_on
	
	#Notification of button up when an edition tool is active
	if @frozen && @edition_active
		return true
	end
	
	#Freeze / unfreeze of the magnifier location
	toggle_freeze
	
	true
end

#CLICK: Double Click received
def onLButtonDoubleClick(flags, x, y, view)
	if !@frozen
		@ip.pick view, x, y
		if [@ip.vertex, @ip.edge, @ip.face].find { |a| a }
			toggle_freeze
			@view.invalidate
		else
			activation false
		end	
	else	
		activation false
	end	
end

#------------------------------------------------------------------------------------
# MENU: Contribution to Contextual Menu
#------------------------------------------------------------------------------------

#MENU: Contextual menu
def contextual_menu_contribution(cxmenu)
	#Entity operations
	if @frozen && @pick_info_cur
		e = edition_entity_under_mouse(@pick_info_cur)
		if e.class == Sketchup::Edge
			cxmenu.add_item("Explode Curve") { edition_explode_curve e } if e.curve
			cxmenu.add_item("Make Face") { edition_make_face e }
		end
	end
	
	#Toggle Freeze mode
	cxmenu.add_sepa
	text = (@frozen) ? T6[:TIP_MagnifierUnFreeze] : T6[:TIP_MagnifierFreeze]
	cxmenu.add_item(text) { toggle_freeze }

	#Display mode
	cxmenu.add_sepa
	cxmenu.add_item(T6[:MNU_MagnifierSwitchFixed]) { set_display_mode nil } unless @glass_mode_old == nil
	cxmenu.add_item(T6[:MNU_MagnifierSwitchShifted]) { set_display_mode :shifted } unless @glass_mode_old == :shifted
	cxmenu.add_item(T6[:MNU_MagnifierSwitchCentered]) { set_display_mode :centered } unless @glass_mode_old == :centered

	#Zoom Min and Max
	cxmenu.add_sepa
	text = "#{@mnu_zoom_min} [#{@zoom_factor_min}]"
	cxmenu.add_item(text) { set_zoom_factor @zoom_factor_min } unless @zoom_factor <= @zoom_factor_min
	text = "#{@mnu_zoom_max} [#{@zoom_factor_max}]"
	cxmenu.add_item(text) { set_zoom_factor @zoom_factor_max } unless @zoom_factor >= @zoom_factor_max

	#Zoom auto
	cxmenu.add_sepa
	if !@no_zoom_auto && @notify_proc
		cxmenu.add_item(T6[:MNU_MagnifierZoomAuto]) { toggle_zoom_auto }	
	end
	
	#Option for displaying vertices
	cxmenu.add_sepa
	text = (@option_display_vertices) ? T6[:MNU_MagnifierHideVertices] : T6[:MNU_MagnifierShowVertices]
	cxmenu.add_item(text) { toggle_display_vertices }

	#Help
	cxmenu.add_sepa
	cxmenu.add_item(T6[:MNU_MagnifierHelp]) { help_display }
end

#---------------------------------------------------------------------------------------------
# PALETTE: Floating palette
#---------------------------------------------------------------------------------------------

#PALETTE: Floating Palette
def palette_contribution(palette)
	@palette = palette
	draw_local = self.method "draw_button_opengl"
	draw_zone = self.method "instructions_for_palette"
	
	#Parameters for the layout
	bk_color = 'lightblue'
	hi_color = 'lightgreen'
		
	#Dimensions
	widtot = @dx + @glass_frame_width * 2
	nbut = 5
	nbutd = 3
	widbut = 32
	widbutd = 24
	height = widbut
	widsepa = 12
	nsepa = 4
	widsepa_f = 4
	widf_min = 50
	widfield = widtot - nbut * widbut - nbutd * widbutd - nsepa * widsepa - widsepa_f
	if widfield < widf_min
		widsepa = (widtot - widf_min - nbut * widbut - nbutd * widbutd - widsepa_f) / nsepa
		widfield = widf_min
	end
	hsh_sepa = { :passive => true, :width => widsepa, :height => height, :draw_proc => :separator_V	}
	
	#Declare the floating palette
	@flpal = flpal = :pal_floating___magnifier
	#hidden_proc = proc { !@magnifier_on || @glass_mode }
	hidden_proc = proc { !@magnifier_on }
	hsh = { :title => T6[:TIT_Magnifier], :hidden_proc => hidden_proc }
	@palette.declare_floating flpal, hsh
		
	#Building the texts and tips
	row = 0
	hshp = { :floating => flpal, :row => row }

	#Vertex display
	symb = "#{flpal}_vertex".intern
	value_proc = proc { @option_display_vertices }
	hsh = { :value_proc => value_proc, :width => widbut, :draw_proc => draw_local, :hi_color => hi_color,
            :tooltip => T6[:TIP_MagnifierToggleVertex] }
	@palette.declare_button(symb, hshp, hsh) { toggle_display_vertices }

	#Separator
	@palette.declare_button("#{flpal}_sepa0".intern, hshp, hsh_sepa) if widsepa > 0
	
	#Zoom OUT
	symb = "#{flpal}_zoom_out".intern
	long_click_proc = proc { set_zoom_factor :min }
	grayed_proc = proc { @zoom_factor <= @zoom_factor_min }
	hsh = { :width => widbut, :draw_proc => draw_local, :grayed_proc => grayed_proc, :bk_color => bk_color,
            :tooltip => T6[:TIP_MagnifierZoomOut], :long_click_proc => long_click_proc }
	@palette.declare_button(symb, hshp, hsh) { set_zoom_factor :minus }

	#Button for zoom factor
	symb = "#{flpal}_factor_title".intern
	hsh_dim = { :height => 16, :width => widfield }
	if @notify_proc && !@no_zoom_auto
		title = T6[:BOX_MagnifierZoomAuto]
		tip = T6[:TIP_MagnifierZoomAuto]
		value_proc = proc { @zoom_auto }
		hsh = { :text => title, :bk_color => bk_color, :hi_color => 'thistle', :tooltip => tip, 
		        :value_proc => value_proc, :rank => 1 }
		@palette.declare_button(symb, hshp, hsh_dim, hsh) { toggle_zoom_auto }
	else
		title = T6[:BOX_MagnifierZoom]
		tip = T6[:TIP_MagnifierZoomValue]
		hsh = { :passive => true, :text => title, :bk_color => bk_color, :tooltip => tip, :rank => 1 }
		@palette.declare_button symb, hshp, hsh_dim, hsh	
	end
	
	#Input field
	prompt = T6[:PROMPT_MagnifierZoomValue]
	hshi = { :vtype => :int, :vprompt => prompt, :vsprintf => '%d', :vmin => @zoom_factor_min, :vmax => @zoom_factor_max }
	get_proc = proc { @zoom_factor }
	set_proc = proc { |val| set_zoom_factor val }
	show_proc = proc { |val| "#{val.to_i}x" }
	input = Traductor::InputField.new hshi, { :get_proc => get_proc, :set_proc => set_proc, :vbutsprintf => show_proc }
	
	symb = "#{flpal}_factor_value".intern
	hsh = { :bk_color => 'lightgreen', :input => input, :tooltip => tip }
	@palette.declare_button symb, hshp, hsh_dim, hsh 
		
	#Zoom IN
	symb = "#{flpal}_zoom_in".intern
	long_click_proc = proc { set_zoom_factor :max }
	grayed_proc = proc { @zoom_factor >= @zoom_factor_max }
	hsh = { :width => widbut, :draw_proc => draw_local, :grayed_proc => grayed_proc, :bk_color => bk_color,
            :tooltip => T6[:TIP_MagnifierZoomIn], :long_click_proc => long_click_proc }
	@palette.declare_button(symb, hshp, hsh) { set_zoom_factor :plus }

	#Separator
	@palette.declare_button("#{flpal}_sepa1".intern, hshp, hsh_sepa) if widsepa > 0
	
	#Display mode for magnifier glass
	symb_master = "#{flpal}_display_bandeau".intern
	hsh = { :type => 'multi_free', :passive => true, :bk_color =>'green',
	        :height => 8, :tooltip => T6[:TIP_MagnifierDisplayMode] }
	@palette.declare_button(symb_master, hshp, hsh)
	hshm = { :parent => symb_master, :height => widbutd, :width => widbutd, :hi_color => hi_color, :draw_proc => draw_local }
	
	symb = "#{flpal}_display_mode_shifted".intern
	value_proc = proc { @glass_mode_old == :shifted }
	hsh = { :value_proc => value_proc, :tooltip => T6[:TIP_MagnifierDisplayModeShifted] }
	@palette.declare_button(symb, hshp, hshm, hsh) { set_display_mode :shifted }

	symb = "#{flpal}_display_mode_centered".intern
	value_proc = proc { @glass_mode_old == :centered }
	hsh = { :value_proc => value_proc, :tooltip => T6[:TIP_MagnifierDisplayModeCentered] }
	@palette.declare_button(symb, hshp, hshm, hsh) { set_display_mode :centered }

	symb = "#{flpal}_display_mode_fixed".intern
	value_proc = proc { !@glass_mode_old }
	hsh = { :value_proc => value_proc, :tooltip => T6[:TIP_MagnifierDisplayModeFixed] }
	@palette.declare_button(symb, hshp, hshm, hsh) { set_display_mode nil }
	
	#Separator
	@palette.declare_button("#{flpal}_sepa2".intern, hshp, hsh_sepa) if widsepa > 0
	
	#Help on Magnifier
	symb = "#{flpal}_help".intern
	hsh = { :width => widbut, :draw_proc => :std_help, :tooltip => T6[:MNU_MagnifierHelp], :main_color => 'blue' }
	@palette.declare_button(symb, hshp, hsh) { help_display }

	#Separator
	@palette.declare_button("#{flpal}_sepa3".intern, hshp, hsh_sepa) if widsepa > 0
	
	#Exit Magnifier
	symb = "#{flpal}_exit".intern
	hsh = { :width => widbut, :draw_proc => :std_exit, :tooltip => T6[:TIP_MagnifierExit] }
	@palette.declare_button(symb, hshp, hsh) { activation false }

	#Unfreeze
	hidden_proc = proc { !@frozen }
	symb = "#{flpal}_sepa6".intern
	hsh = { :witdh => widsepa_f, :hidden_proc => hidden_proc }
	@palette.declare_button(symb, hshp, hsh_sepa, hsh)
	symb = "#{flpal}_unfreeze".intern
	hsh = { :width => widbut, :draw_proc => draw_local, :hidden_proc => hidden_proc, :tooltip => T6[:TIP_MagnifierUnFreeze] }
	@palette.declare_button(symb, hshp, hsh) { toggle_freeze }

	#Drawing_zone
	row += 1
	@palette_zone_button = symb = "#{flpal}_drawing_zone".intern
	dy = @dy + @glass_frame_width * 2
	hidden_proc = proc { @glass_mode }
	zone_proc = self.method "edition_dispatch_event"
	cursor_proc = self.method "edition_cursor"
	hsh = { :floating => flpal, :passive => true, :height => dy, :width => widtot, :row => row, :bk_color => 'gold',
            :hidden_proc => hidden_proc, :draw_proc => draw_zone, 
			:draw_refresh => true, :zone_proc => zone_proc, :cursor_proc => cursor_proc }
	@palette.declare_button symb, hsh	
	
	#Separation button
	hidden_proc = proc { !@frozen }
	symb = "#{flpal}_vsepa".intern
	hsh = { :floating => flpal, :height => dy, :width => widsepa_f, :hidden_proc => hidden_proc }
	@palette.declare_button symb, hsh	
	
	#Buttons for edition in Frozen mode
	buttons = [:select, :unselect, :edit_sepa0, :tape, :edit_sepa1, :move, :edit_sepa2, :eraser, :edit_sepa3, :repair, :ignore, :edit_sepa4, :rollback]
	but_sepa = buttons.find_all { |symb| symb.to_s =~ /sepa/ }
	but_eds = buttons.find_all { |symb| symb.to_s !~ /sepa/ }
	but_eds_no = []
	hsepa = 8
	nbuttons = buttons.length
	nbut_eds = but_eds.length
	nbut_sepa = but_sepa.length
	htot = dy
	h = (htot - nbut_sepa * hsepa) / nbut_eds
	w = h 
	hshc = { :floating => flpal, :height => h, :width => w, :hi_color => 'gold',
             :hidden_proc => hidden_proc }
	buttons.each_with_index do |sbut, i|
		symb = "#{flpal}_edition_#{sbut}".intern
		rank = nbuttons - i - 1
		if sbut.to_s =~ /sepa/
			hsh = { :rank => rank, :passive => true, :height => hsepa, :draw_proc => :separator_H }
			@palette.declare_button(symb, hshc, hsh)
		elsif sbut == :rollback
			proc_gray = palette_proc_edition_grayed(sbut)
			hsh = { :tooltip => T6[:T_STR_UndoCtrlZ], :draw_proc => :rollback, :grayed_proc => proc_gray }
			@palette.declare_button(symb, hshc, hsh) { edition_undo }		
		else
			tip = palette_tip_edition_tool(sbut)
			if but_eds_no.include?(sbut)
				proc_edit = proc { UI.messagebox "Not yet implemented" }
				proc_val = proc { false }
			else
				proc_edit = palette_proc_edition_action(sbut)
				proc_val = palette_proc_edition_value(sbut)
			end	
			proc_gray = palette_proc_edition_grayed(sbut)
			hsh = { :rank => rank, :value_proc => proc_val, :tooltip => tip, :draw_proc => "std_edition_#{sbut}".intern,
                    :grayed_proc => proc_gray }
			@palette.declare_button(symb, hshc, hsh) { proc_edit.call }
		end	
	end		
end

def palette_tip_edition_tool(sbut)
	tip = T6["TIP_MagnifierEdition__#{sbut}".intern]
	unless sbut == :unselect
		tip2 = ((sbut == :move || sbut == :tape) && !@enable_panning_tape_move) ? T6[:TIP_MagnifierEdition_pan_shift] : T6[:TIP_MagnifierEdition_pan]
		tip += ' ' + tip2
	end	
	tip
end

def palette_proc_edition_rollback ; proc { (@notify_proc) ? @notify_proc.call(:undo) : Sketchup.undo } ; end
def palette_proc_edition_action(sbut) ; proc { edition_set_tool sbut } ; end
def palette_proc_edition_value(sbut) ; proc { @edition_tool == sbut } ; end
def palette_proc_edition_grayed(sbut) ; proc { palette_edition_check_grayed sbut } ; end
	
def palette_edition_check_grayed(sbut)
	case sbut
	when :repair, :ignore
		return true unless @notify_proc
		return @notify_proc.call(:gray_check)
	when :rollback
		return true unless @notify_proc
		return @notify_proc.call(:gray_undo)
	end
	false
end

#PALETTE: Custom drawing of buttons
def draw_button_opengl(symb, dx, dy, main_color, frame_color, selected, grayed)
	code = symb.to_s
	lst_gl = []
	dx2 = dx / 2
	dy2 = dy / 2
	color = (grayed) ? 'gray' : frame_color
	
	case code
	
	when /zoom_(.)/
		color = (grayed) ? 'gray' : 'black'
		dec = 8
		pts = G6.pts_circle dx2, dy2, dx2-2
		lst_gl.push [GL_LINE_LOOP, pts, color, 1, '']		
		pts = [Geom::Point3d.new(dx2-dec, dy2), Geom::Point3d.new(dx2+dec, dy2)]
		pts += [Geom::Point3d.new(dx2, dy2-dec), Geom::Point3d.new(dx2, dy2+dec)] if $1 == 'i'
		lst_gl.push [GL_LINES, pts, color, 2, '']		
		
	when /vertex/
		dec = 2
		pts = []
		pts.push Geom::Point3d.new(4, 4)
		pts.push Geom::Point3d.new(dx2, dy-4)
		pts.push Geom::Point3d.new(dx-4, 6)
		lst_gl.push [GL_LINE_STRIP, pts, 'black', 1, '']
		
		pts.each do |pt|
			lst_gl.push [GL_POLYGON, G6.pts_square(pt.x, pt.y, dec), @color_vertices]
		end	
				
	when /display_mode_centered/
		dec = dx2 - 2
		pts = G6.pts_square dx2, dy2, dec
		lst_gl.push [GL_POLYGON, pts, @su_background_color]
		lst_gl.push [GL_LINE_LOOP, pts, @color_glass_frame, 2, '']
		dec = 3
		pts = G6.pts_square dx2, dy2, dec
		lst_gl.push [GL_POLYGON, pts, 'lightyellow']
		lst_gl.push [GL_LINE_LOOP, pts, @color_explorer_frame, 2, '']

	when /display_mode_shifted/
		dx4 = dx / 4
		dy4 = dy / 4
		dec = 3
		pts = G6.pts_square dx4, dy4, dec
		lst_gl.push [GL_POLYGON, pts, 'lightyellow']
		lst_gl.push [GL_LINE_LOOP, pts, @color_explorer_frame, 2, '']
		dec = dx2 - 5
		pts = G6.pts_square dx2+4, dy2, dec
		lst_gl.push [GL_POLYGON, pts, @su_background_color]
		lst_gl.push [GL_LINE_LOOP, pts, @color_glass_frame, 2, '']

	when /display_mode_fixed/
		dx4 = dx / 4
		dy4 = dy / 4
		dec = dx2-4
		pts = G6.pts_square dx2, dy2-2, dec
		lst_gl.push [GL_POLYGON, pts, @su_background_color]
		lst_gl.push [GL_LINE_LOOP, pts, @color_glass_frame, 2, '']
		y = dy2-2+dec
		lpti = [[dx2-dec, y], [dx2+dec, y], [dx2+dec, y+4], [dx2-dec, y+4]]
		pts = lpti.collect { |a| Geom::Point3d.new(*a) }
		lst_gl.push [GL_POLYGON, pts, 'gray']
		lst_gl.push [GL_LINE_LOOP, pts, @color_glass_frame, 2, '']

	when /unfreeze/
		dec = 6
		pts = G6.pts_square dx2, dy2-dec, dec
		lst_gl.push [GL_POLYGON, pts, 'black']
		color = (grayed) ? 'gray' : 'white'
		lst_gl.push [GL_LINE_LOOP, pts, color, 2, '']
		x = dx2 + dec - 2
		lpti = [[x, dy2], [x, dy2+6], [x-2, dy2+8], [x-5, dy2+9], [x-8, dy2+8], [dx2-dec, dy2+6]]
		pts = lpti.collect { |a| Geom::Point3d.new(*a) }
		lst_gl.push [GL_LINE_STRIP, pts, 'white', 5, '']
		lst_gl.push [GL_LINE_STRIP, pts, 'black', 2, '']
		
		
	end	#case code
	
	lst_gl
end

#---------------------------------------------------------------------------------------------
# HELP: Help on Magnifier
#---------------------------------------------------------------------------------------------

#HELP: Display the help window
def help_display
	Traductor::MagnifierHelpDialog.display
end

end	#class Magnifier


#=============================================================
#-------------------------------------------------------------
# Class MagnifierHelpDialog: Dialog box for help
#-------------------------------------------------------------
#=============================================================

class MagnifierHelpDialog

#HELP_DIALOG: Invoke the Parameter dialog box
def MagnifierHelpDialog.display
	key = 'LibFredo6-Magnifier-KeyHelp'
	MagnifierHelpDialog.new(key) unless Traductor::Wdlg.check_instance_displayed(key)
end

#HELP_DIALOG: Calculate the dialog box
def initialize(unique_key)
	@wdlg_key = unique_key
	@wid_col1 = (@type == 'F') ? 250 : 170
	@wid_colT = 100
	@wid_colP = 80
	
	@title = T6[:MNU_MagnifierHelp]
	@wdlg = create_dialog(unique_key)
end	

#HELP_DIALOG: Create the dialog box
def create_dialog(unique_key)
	wdlg = Traductor::Wdlg.new @title, @wdlg_key, false
	wdlg.set_unique_key unique_key
	@wid_section = 150
	@wid_desc = 500
	wid = @wid_section + @wid_desc + 20
	wdlg.set_size wid, 600
	wdlg.set_background_color 'lightyellow'
	wdlg.set_callback self.method('dialog_callback') 
	wdlg.set_on_close { on_close() }
	html = format_html wdlg
	wdlg.set_html html
	wdlg.show
	wdlg
end

#HELP_DIALOG: procedure executed when the dialog box closes
def on_close
	@notify_close_proc.call(self) if @notify_close_proc
end

#HELP_DIALOG: Close the dialog box
def close_dialog
	@wdlg.close
end

#HELP_DIALOG: Call back for Statistics Dialog
def dialog_callback(event, type, id, svalue)
	case event
	
	#Command buttons
	when /onclick/i
		case id
		when 'ButtonDone'
			@wdlg.close
		when 'ButtonPrint'
			@wdlg.print
		end
	
	when /onKeyUp/i	#Escape and Return key
		@wdlg.close if svalue =~ /\A27\*/ || svalue =~ /\A13\*/
		
	end
end

#HELP_DIALOG: Build the HTML for Statistics Dialog
def format_html(wdlg)
	
	#Creating the HTML stream	
	html = Traductor::HTML.new
	
	#Color Setting
	@col_border_key = '1px solid blue'
	@col_border_vcb = '1px solid goldenrod'
	
	#Style used in the dialog box	
	@border_key = "border-bottom: #{@col_border_key} ; border-top: #{@col_border_key}"
	@border_vcb = "border-bottom: #{@col_border_vcb} ; border-top: #{@col_border_vcb}"
	
	html.create_style 'Title', nil, 'B', 'K: navy', 'F-SZ: 18', 'text-align: center'
	html.create_style 'GENE_key', nil, 'BG: lightblue'
	html.create_style 'GENE_desc', nil, 'BG: lightsteelblue'
	html.create_style 'EDIT_key', nil, 'BG: lemonchiffon'
	html.create_style 'EDIT_desc', nil, 'BG: khaki'
	html.create_style 'HeaderGene', nil, 'B', 'BG: royalblue', 'F-SZ: 12', 'K:white', 'text-align: center', @border_key
	html.create_style 'HeaderEdit', nil, 'B', 'BG: sienna', 'F-SZ: 12', 'K:white', 'text-align: center', @border_vcb
	html.create_style 'CellKey', nil, 'K: black', 'F-SZ: 11', 'text-align: left', 'padding-left: 8px'
	html.create_style 'CellDesc', nil, 'K: black', 'F-SZ: 11', 'text-align: left', 'padding-left: 8px'
	html.create_style 'Button', nil, 'F-SZ: 10'
	
	#Styling for screen and printing
	main_div_height = 410
	text = "<style type='text/css' media='screen'>"
	text += ".MAIN_DIV_Style {position: relative; height: #{main_div_height}px; overflow-y: auto; overflow-x: hidden; border:2px solid sienna}"
	text += "</style>"
	html.body_add text
	
	#Creating the title
	html.body_add "<div cellspacing='0px' cellpadding='0px' class='Title T_NOSCREEN_Style Title'>#{@title}</div>"
	
	#Inserting the main table
	text = ""
	text += "<div width='100%' class='MAIN_DIV_Style DivTable'>"

	tx_esc = T6[:T_KEY_ESC]
	tx_tab = T6[:T_KEY_TAB]
	tx_vcb = T6[:T_KEY_VCB]
	tx_mousewheel = T6[:T_KEY_MouseWheel]
	tx_ctrl = T6[:T_KEY_Ctrl]
	tx_shift = T6[:T_KEY_SHIFT]
	tx_arrow_right = T6[:T_KEY_ArrowRight]
	tx_arrow_left = T6[:T_KEY_ArrowLeft]
	tx_arrow_up = T6[:T_KEY_ArrowUp]
	tx_arrow_down = T6[:T_KEY_ArrowDown]
	
	#Table for Zooming General Help
	title = T6[:HLP_Magnifier_SectionGeneral]
	text += "<br><div cellspacing='0px' cellpadding='0px' class='Title'>#{title}</div>"
	text += "<table width='100%' cellspacing='0px' cellpadding='0px' border>"
	text += "<tr><td class='HeaderGene' align='center'>#{T6[:T_KEY_Key]}</td>"
	text += "<td class='HeaderGene' align='center'>#{T6[:T_STR_Description]}</td></tr>"

	text += html_gene_row tx_esc, T6[:HLP_Magnifier_Exit]
	text += html_gene_row tx_mousewheel, T6[:HLP_Magnifier_ZoomSU]
	text += html_gene_row tx_ctrl + '+' + tx_mousewheel, T6[:HLP_Magnifier_ZoomGlass]
	text += html_gene_row tx_vcb, T6[:HLP_Magnifier_VCB]
	text += html_gene_row tx_arrow_up, T6[:HLP_Magnifier_ZoomIN]
	text += html_gene_row tx_arrow_down, T6[:HLP_Magnifier_ZoomOUT]
	text += html_gene_row tx_arrow_left, T6[:HLP_Magnifier_ZoomMIN]
	text += html_gene_row tx_arrow_right, T6[:HLP_Magnifier_ZoomMAX]
	text += html_gene_row tx_tab, T6[:HLP_Magnifier_DisplayMode]

	text += "</table>"	

	#Table for Zooming General Help
	title = T6[:HLP_Magnifier_SectionEdit]
	text += "<br><div cellspacing='0px' cellpadding='0px' class='Title'>#{title}</div>"
	text += "<table width='100%' cellspacing='0px' cellpadding='0px' border>"
	text += "<tr><td class='HeaderEdit' align='center'>#{T6[:T_KEY_Key]}</td>"
	text += "<td class='HeaderEdit' align='center'>#{T6[:T_STR_Description]}</td></tr>"

	text += html_edit_row T6[:HLP_Magnifier_UnFreeze], T6[:HLP_Magnifier_UnFreezeKeys]
	text += html_edit_row T6[:HLP_Magnifier_Zooming], "#{tx_mousewheel} - #{tx_ctrl + '+' + tx_mousewheel}"
	text += html_edit_row T6[:HLP_Magnifier_Panning], T6[:HLP_Magnifier_PanningKeys]
	text += html_edit_row T6[:HLP_Magnifier_Select], T6[:HLP_Magnifier_SelectKeys]
	text += html_edit_row T6[:HLP_Magnifier_Del], T6[:HLP_Magnifier_DelKeys]
	text += html_edit_row T6[:HLP_Magnifier_Tape], T6[:HLP_Magnifier_TapeKeys]
	text += html_edit_row T6[:HLP_Magnifier_Move], T6[:HLP_Magnifier_TapeKeys]
	text += html_edit_row T6[:HLP_Magnifier_Eraser], T6[:HLP_Magnifier_EraserKeys]
	
	text += "</table>"	

	#End of scrolling DIV
	text += "</div>"	
	html.body_add text	
	
	#Creating the DONE button
	butdone = Traductor::HTML.format_button T6[:T_BUTTON_Done], "ButtonDone", 'Button', nil
	butprint = Traductor::HTML.format_button T6[:T_BUTTON_Print], id="ButtonPrint", 'Button', nil
	html.body_add "<table class='T_NOPRINT_Style' width='99%' cellpadding='6px'><tr>"
	html.body_add "<td width='50%' align='left'>", butprint, "</td>"
	html.body_add "<td align='right'>", butdone, "</td>"
	html.body_add "</tr></table>"
	
	#Returning the HTML object
	html	
end

#HELP_DIALOG: Build the HTML for a row in the General section
def html_gene_row(txkey, txdesc)
	"<tr><td class='CellKey GENE_key'>#{txkey}</td><td class='CellDesc GENE_desc'>#{txdesc}</td></tr>"
end

#HELP_DIALOG: Build the HTML for a row in the Edit section
def html_edit_row(txkey, txdesc)
	"<tr><td class='CellKey EDIT_key'>#{txkey}</td><td class='CellDesc EDIT_desc'>#{txdesc}</td></tr>"
end

end	#class MagnifierHelpDialog

end	#End Module Traductor
